/*
 React
 react-dom-server-legacy.node.production.min.js

 Copyright (c) Meta Platforms, Inc. and affiliates.

 This source code is licensed under the MIT license found in the
 LICENSE file in the root directory of this source tree.


 JS Implementation of MurmurHash3 (r136) (as of May 20, 2011)

 Copyright (c) 2011 Gary Court
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
*/
'use strict';var aa=require("next/dist/compiled/react-experimental"),ba=require("react-dom"),ea=require("stream");
function fa(a,b){var c=a.length&3;var d=a.length-c;var e=b;for(b=0;b<d;){var f=a.charCodeAt(b)&255|(a.charCodeAt(++b)&255)<<8|(a.charCodeAt(++b)&255)<<16|(a.charCodeAt(++b)&255)<<24;++b;f=3432918353*(f&65535)+((3432918353*(f>>>16)&65535)<<16)&4294967295;f=f<<15|f>>>17;f=461845907*(f&65535)+((461845907*(f>>>16)&65535)<<16)&4294967295;e^=f;e=e<<13|e>>>19;e=5*(e&65535)+((5*(e>>>16)&65535)<<16)&4294967295;e=(e&65535)+27492+(((e>>>16)+58964&65535)<<16)}f=0;switch(c){case 3:f^=(a.charCodeAt(b+2)&255)<<
16;case 2:f^=(a.charCodeAt(b+1)&255)<<8;case 1:f^=a.charCodeAt(b)&255,f=3432918353*(f&65535)+((3432918353*(f>>>16)&65535)<<16)&4294967295,f=f<<15|f>>>17,e^=461845907*(f&65535)+((461845907*(f>>>16)&65535)<<16)&4294967295}e^=a.length;e^=e>>>16;e=2246822507*(e&65535)+((2246822507*(e>>>16)&65535)<<16)&4294967295;e^=e>>>13;e=3266489909*(e&65535)+((3266489909*(e>>>16)&65535)<<16)&4294967295;return(e^e>>>16)>>>0}
var v=Object.assign,y=Object.prototype.hasOwnProperty,la=RegExp("^[:A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD][:A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040]*$"),ma={},na={};
function za(a){if(y.call(na,a))return!0;if(y.call(ma,a))return!1;if(la.test(a))return na[a]=!0;ma[a]=!0;return!1}
var Aa=new Set("animationIterationCount aspectRatio borderImageOutset borderImageSlice borderImageWidth boxFlex boxFlexGroup boxOrdinalGroup columnCount columns flex flexGrow flexPositive flexShrink flexNegative flexOrder gridArea gridRow gridRowEnd gridRowSpan gridRowStart gridColumn gridColumnEnd gridColumnSpan gridColumnStart fontWeight lineClamp lineHeight opacity order orphans scale tabSize widows zIndex zoom fillOpacity floodOpacity stopOpacity strokeDasharray strokeDashoffset strokeMiterlimit strokeOpacity strokeWidth MozAnimationIterationCount MozBoxFlex MozBoxFlexGroup MozLineClamp msAnimationIterationCount msFlex msZoom msFlexGrow msFlexNegative msFlexOrder msFlexPositive msFlexShrink msGridColumn msGridColumnSpan msGridRow msGridRowSpan WebkitAnimationIterationCount WebkitBoxFlex WebKitBoxFlexGroup WebkitBoxOrdinalGroup WebkitColumnCount WebkitColumns WebkitFlex WebkitFlexGrow WebkitFlexPositive WebkitFlexShrink WebkitLineClamp".split(" ")),Ba=
new Map([["acceptCharset","accept-charset"],["htmlFor","for"],["httpEquiv","http-equiv"],["crossOrigin","crossorigin"],["accentHeight","accent-height"],["alignmentBaseline","alignment-baseline"],["arabicForm","arabic-form"],["baselineShift","baseline-shift"],["capHeight","cap-height"],["clipPath","clip-path"],["clipRule","clip-rule"],["colorInterpolation","color-interpolation"],["colorInterpolationFilters","color-interpolation-filters"],["colorProfile","color-profile"],["colorRendering","color-rendering"],
["dominantBaseline","dominant-baseline"],["enableBackground","enable-background"],["fillOpacity","fill-opacity"],["fillRule","fill-rule"],["floodColor","flood-color"],["floodOpacity","flood-opacity"],["fontFamily","font-family"],["fontSize","font-size"],["fontSizeAdjust","font-size-adjust"],["fontStretch","font-stretch"],["fontStyle","font-style"],["fontVariant","font-variant"],["fontWeight","font-weight"],["glyphName","glyph-name"],["glyphOrientationHorizontal","glyph-orientation-horizontal"],["glyphOrientationVertical",
"glyph-orientation-vertical"],["horizAdvX","horiz-adv-x"],["horizOriginX","horiz-origin-x"],["imageRendering","image-rendering"],["letterSpacing","letter-spacing"],["lightingColor","lighting-color"],["markerEnd","marker-end"],["markerMid","marker-mid"],["markerStart","marker-start"],["overlinePosition","overline-position"],["overlineThickness","overline-thickness"],["paintOrder","paint-order"],["panose-1","panose-1"],["pointerEvents","pointer-events"],["renderingIntent","rendering-intent"],["shapeRendering",
"shape-rendering"],["stopColor","stop-color"],["stopOpacity","stop-opacity"],["strikethroughPosition","strikethrough-position"],["strikethroughThickness","strikethrough-thickness"],["strokeDasharray","stroke-dasharray"],["strokeDashoffset","stroke-dashoffset"],["strokeLinecap","stroke-linecap"],["strokeLinejoin","stroke-linejoin"],["strokeMiterlimit","stroke-miterlimit"],["strokeOpacity","stroke-opacity"],["strokeWidth","stroke-width"],["textAnchor","text-anchor"],["textDecoration","text-decoration"],
["textRendering","text-rendering"],["transformOrigin","transform-origin"],["underlinePosition","underline-position"],["underlineThickness","underline-thickness"],["unicodeBidi","unicode-bidi"],["unicodeRange","unicode-range"],["unitsPerEm","units-per-em"],["vAlphabetic","v-alphabetic"],["vHanging","v-hanging"],["vIdeographic","v-ideographic"],["vMathematical","v-mathematical"],["vectorEffect","vector-effect"],["vertAdvY","vert-adv-y"],["vertOriginX","vert-origin-x"],["vertOriginY","vert-origin-y"],
["wordSpacing","word-spacing"],["writingMode","writing-mode"],["xmlnsXlink","xmlns:xlink"],["xHeight","x-height"]]),Ca=/["'&<>]/;
function z(a){if("boolean"===typeof a||"number"===typeof a)return""+a;a=""+a;var b=Ca.exec(a);if(b){var c="",d,e=0;for(d=b.index;d<a.length;d++){switch(a.charCodeAt(d)){case 34:b="&quot;";break;case 38:b="&amp;";break;case 39:b="&#x27;";break;case 60:b="&lt;";break;case 62:b="&gt;";break;default:continue}e!==d&&(c+=a.slice(e,d));e=d+1;c+=b}a=e!==d?c+a.slice(e,d):c}return a}
var Da=/([A-Z])/g,Ea=/^ms-/,Ka=Array.isArray,La=aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,Ma={pending:!1,data:null,method:null,action:null},Na=ba.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.Dispatcher,kb={prefetchDNS:Oa,preconnect:Pa,preload:Qa,preloadModule:Ra,preinitStyle:Sa,preinitScript:ib,preinitModuleScript:jb},B=[],lb=/(<\/|<)(s)(cript)/gi;function mb(a,b,c,d){return""+b+("s"===c?"\\u0073":"\\u0053")+d}
function nb(a,b,c,d,e){var f=0;void 0!==b&&(f=1);return{idPrefix:void 0===a?"":a,nextFormID:0,streamingFormat:f,bootstrapScriptContent:c,bootstrapScripts:d,bootstrapModules:e,instructions:0,hasBody:!1,hasHtml:!1,unknownResources:{},dnsResources:{},connectResources:{default:{},anonymous:{},credentials:{}},imageResources:{},styleResources:{},scriptResources:{},moduleUnknownResources:{},moduleScriptResources:{}}}function G(a,b,c){return{insertionMode:a,selectedValue:b,tagScope:c}}
function ob(a){return G("http://www.w3.org/2000/svg"===a?3:"http://www.w3.org/1998/Math/MathML"===a?4:0,null,0)}
function pb(a,b,c){switch(b){case "noscript":return G(2,null,a.tagScope|1);case "select":return G(2,null!=c.value?c.value:c.defaultValue,a.tagScope);case "svg":return G(3,null,a.tagScope);case "picture":return G(2,null,a.tagScope|2);case "math":return G(4,null,a.tagScope);case "foreignObject":return G(2,null,a.tagScope);case "table":return G(5,null,a.tagScope);case "thead":case "tbody":case "tfoot":return G(6,null,a.tagScope);case "colgroup":return G(8,null,a.tagScope);case "tr":return G(7,null,a.tagScope)}return 5<=
a.insertionMode?G(2,null,a.tagScope):0===a.insertionMode?"html"===b?G(1,null,a.tagScope):G(2,null,a.tagScope):1===a.insertionMode?G(2,null,a.tagScope):a}var qb=new Map;
function rb(a,b){if("object"!==typeof b)throw Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");var c=!0,d;for(d in b)if(y.call(b,d)){var e=b[d];if(null!=e&&"boolean"!==typeof e&&""!==e){if(0===d.indexOf("--")){var f=z(d);e=z((""+e).trim())}else f=qb.get(d),void 0===f&&(f=z(d.replace(Da,"-$1").toLowerCase().replace(Ea,"-ms-")),qb.set(d,f)),e="number"===typeof e?0===e||Aa.has(d)?""+e:e+"px":
z((""+e).trim());c?(c=!1,a.push(' style="',f,":",e)):a.push(";",f,":",e)}}c||a.push('"')}function sb(a,b,c){c&&"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'=""')}function I(a,b,c){"function"!==typeof c&&"symbol"!==typeof c&&"boolean"!==typeof c&&a.push(" ",b,'="',z(c),'"')}function Cb(a){var b=a.nextFormID++;return a.idPrefix+b}var Db=z("javascript:throw new Error('A React form was unexpectedly submitted.')");
function Eb(a,b){this.push('<input type="hidden"');if("string"!==typeof a)throw Error("File/Blob fields are not yet supported in progressive forms. It probably means you are closing over binary data or FormData in a Server Action.");I(this,"name",b);I(this,"value",a);this.push("/>")}
function Fb(a,b,c,d,e,f,g,h){var k=null;"function"===typeof d&&("function"===typeof d.$$FORM_ACTION?(e=Cb(b),b=d.$$FORM_ACTION(e),h=b.name,d=b.action||"",e=b.encType,f=b.method,g=b.target,k=b.data):(a.push(" ","formAction",'="',Db,'"'),g=f=e=d=h=null,Gb(b,c)));null!=h&&J(a,"name",h);null!=d&&J(a,"formAction",d);null!=e&&J(a,"formEncType",e);null!=f&&J(a,"formMethod",f);null!=g&&J(a,"formTarget",g);return k}
function J(a,b,c){switch(b){case "className":I(a,"class",c);break;case "tabIndex":I(a,"tabindex",c);break;case "dir":case "role":case "viewBox":case "width":case "height":I(a,b,c);break;case "style":rb(a,c);break;case "src":case "href":if(""===c)break;case "action":case "formAction":if(null==c||"function"===typeof c||"symbol"===typeof c||"boolean"===typeof c)break;a.push(" ",b,'="',z(""+c),'"');break;case "defaultValue":case "defaultChecked":case "innerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":break;
case "autoFocus":case "multiple":case "muted":sb(a,b.toLowerCase(),c);break;case "xlinkHref":if("function"===typeof c||"symbol"===typeof c||"boolean"===typeof c)break;a.push(" ","xlink:href",'="',z(""+c),'"');break;case "contentEditable":case "spellCheck":case "draggable":case "value":case "autoReverse":case "externalResourcesRequired":case "focusable":case "preserveAlpha":"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'="',z(c),'"');break;case "allowFullScreen":case "async":case "autoPlay":case "controls":case "default":case "defer":case "disabled":case "disablePictureInPicture":case "disableRemotePlayback":case "formNoValidate":case "hidden":case "loop":case "noModule":case "noValidate":case "open":case "playsInline":case "readOnly":case "required":case "reversed":case "scoped":case "seamless":case "itemScope":c&&
"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'=""');break;case "capture":case "download":!0===c?a.push(" ",b,'=""'):!1!==c&&"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'="',z(c),'"');break;case "cols":case "rows":case "size":case "span":"function"!==typeof c&&"symbol"!==typeof c&&!isNaN(c)&&1<=c&&a.push(" ",b,'="',z(c),'"');break;case "rowSpan":case "start":"function"===typeof c||"symbol"===typeof c||isNaN(c)||a.push(" ",b,'="',z(c),'"');break;case "xlinkActuate":I(a,"xlink:actuate",
c);break;case "xlinkArcrole":I(a,"xlink:arcrole",c);break;case "xlinkRole":I(a,"xlink:role",c);break;case "xlinkShow":I(a,"xlink:show",c);break;case "xlinkTitle":I(a,"xlink:title",c);break;case "xlinkType":I(a,"xlink:type",c);break;case "xmlBase":I(a,"xml:base",c);break;case "xmlLang":I(a,"xml:lang",c);break;case "xmlSpace":I(a,"xml:space",c);break;default:if(!(2<b.length)||"o"!==b[0]&&"O"!==b[0]||"n"!==b[1]&&"N"!==b[1])if(b=Ba.get(b)||b,za(b)){switch(typeof c){case "function":case "symbol":return;
case "boolean":var d=b.toLowerCase().slice(0,5);if("data-"!==d&&"aria-"!==d)return}a.push(" ",b,'="',z(c),'"')}}}function L(a,b,c){if(null!=b){if(null!=c)throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");if("object"!==typeof b||!("__html"in b))throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");b=b.__html;null!==b&&void 0!==b&&a.push(""+b)}}
function Hb(a){var b="";aa.Children.forEach(a,function(c){null!=c&&(b+=c)});return b}
function Gb(a,b){0!==(a.instructions&16)||b.externalRuntimeScript||(a.instructions|=16,b.bootstrapChunks.unshift(b.startInlineScript,'addEventListener("submit",function(a){if(!a.defaultPrevented){var c=a.target,d=a.submitter,e=c.action,b=d;if(d){var f=d.getAttribute("formAction");null!=f&&(e=f,b=null)}"javascript:throw new Error(\'A React form was unexpectedly submitted.\')"===e&&(a.preventDefault(),b?(a=document.createElement("input"),a.name=b.name,a.value=b.value,b.parentNode.insertBefore(a,b),b=new FormData(c),a.parentNode.removeChild(a)):b=new FormData(c),a=c.getRootNode(),(a.$$reactFormReplay=a.$$reactFormReplay||[]).push(c,\nd,b))}});',"\x3c/script>"))}
function Ib(a,b,c,d,e,f,g){var h=b.rel,k=b.href,l=b.precedence;if(3===f||g||null!=b.itemProp||"string"!==typeof h||"string"!==typeof k||""===k)return M(a,b),null;if("stylesheet"===b.rel){if("string"!==typeof l||null!=b.disabled||b.onLoad||b.onError)return M(a,b);f=d.styles.get(l);g=c.styleResources.hasOwnProperty(k)?c.styleResources[k]:void 0;null!==g?(c.styleResources[k]=null,f||(f={precedence:z(l),rules:[],hrefs:[],sheets:new Map},d.styles.set(l,f)),b={state:0,props:v({},b,{"data-precedence":b.precedence,
precedence:null})},g&&(2===g.length&&Jb(b.props,g),(c=d.preloads.stylesheets.get(k))&&0<c.length?c.length=0:b.state=1),f.sheets.set(k,b),d.boundaryResources&&d.boundaryResources.stylesheets.add(b)):f&&(k=f.sheets.get(k))&&d.boundaryResources&&d.boundaryResources.stylesheets.add(k);e&&a.push("\x3c!-- --\x3e");return null}if(b.onLoad||b.onError)return M(a,b);e&&a.push("\x3c!-- --\x3e");switch(b.rel){case "preconnect":case "dns-prefetch":return M(d.preconnectChunks,b);case "preload":return M(d.preloadChunks,
b);default:return M(d.hoistableChunks,b)}}function M(a,b){a.push(N("link"));for(var c in b)if(y.call(b,c)){var d=b[c];if(null!=d)switch(c){case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");default:J(a,c,d)}}a.push("/>");return null}
function Kb(a,b,c){a.push(N(c));for(var d in b)if(y.call(b,d)){var e=b[d];if(null!=e)switch(d){case "children":case "dangerouslySetInnerHTML":throw Error(c+" is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");default:J(a,d,e)}}a.push("/>");return null}
function Lb(a,b){a.push(N("title"));var c=null,d=null,e;for(e in b)if(y.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:J(a,e,f)}}a.push(">");b=Array.isArray(c)?2>c.length?c[0]:null:c;"function"!==typeof b&&"symbol"!==typeof b&&null!==b&&void 0!==b&&a.push(z(""+b));L(a,d,c);a.push(Mb("title"));return null}
function Nb(a,b){a.push(N("script"));var c=null,d=null,e;for(e in b)if(y.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:J(a,e,f)}}a.push(">");L(a,d,c);"string"===typeof c&&a.push(z(c));a.push(Mb("script"));return null}
function Ob(a,b,c){a.push(N(c));var d=c=null,e;for(e in b)if(y.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:J(a,e,f)}}a.push(">");L(a,d,c);return"string"===typeof c?(a.push(z(c)),null):c}var Pb=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,Qb=new Map;function N(a){var b=Qb.get(a);if(void 0===b){if(!Pb.test(a))throw Error("Invalid tag: "+a);b="<"+a;Qb.set(a,b)}return b}
function Rb(a,b,c,d,e,f,g){switch(b){case "div":case "span":case "svg":case "path":case "a":case "g":case "p":case "li":break;case "select":a.push(N("select"));var h=null,k=null,l;for(l in c)if(y.call(c,l)){var m=c[l];if(null!=m)switch(l){case "children":h=m;break;case "dangerouslySetInnerHTML":k=m;break;case "defaultValue":case "value":break;default:J(a,l,m)}}a.push(">");L(a,k,h);return h;case "option":var p=f.selectedValue;a.push(N("option"));var n=null,q=null,C=null,A=null,x;for(x in c)if(y.call(c,
x)){var u=c[x];if(null!=u)switch(x){case "children":n=u;break;case "selected":C=u;break;case "dangerouslySetInnerHTML":A=u;break;case "value":q=u;default:J(a,x,u)}}if(null!=p){var t=null!==q?""+q:Hb(n);if(Ka(p))for(var E=0;E<p.length;E++){if(""+p[E]===t){a.push(' selected=""');break}}else""+p===t&&a.push(' selected=""')}else C&&a.push(' selected=""');a.push(">");L(a,A,n);return n;case "textarea":a.push(N("textarea"));var w=null,r=null,D=null,O;for(O in c)if(y.call(c,O)){var F=c[O];if(null!=F)switch(O){case "children":D=
F;break;case "value":w=F;break;case "defaultValue":r=F;break;case "dangerouslySetInnerHTML":throw Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");default:J(a,O,F)}}null===w&&null!==r&&(w=r);a.push(">");if(null!=D){if(null!=w)throw Error("If you supply `defaultValue` on a <textarea>, do not pass children.");if(Ka(D)){if(1<D.length)throw Error("<textarea> can only have at most one child.");w=""+D[0]}w=""+D}"string"===typeof w&&"\n"===w[0]&&a.push("\n");null!==w&&a.push(z(""+w));
return null;case "input":a.push(N("input"));var ha=null,R=null,P=null,oa=null,ia=null,Y=null,Ta=null,Ua=null,Va=null,pa;for(pa in c)if(y.call(c,pa)){var S=c[pa];if(null!=S)switch(pa){case "children":case "dangerouslySetInnerHTML":throw Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");case "name":ha=S;break;case "formAction":R=S;break;case "formEncType":P=S;break;case "formMethod":oa=S;break;case "formTarget":ia=S;break;case "defaultChecked":Va=
S;break;case "defaultValue":Ta=S;break;case "checked":Ua=S;break;case "value":Y=S;break;default:J(a,pa,S)}}var tb=Fb(a,d,e,R,P,oa,ia,ha);null!==Ua?sb(a,"checked",Ua):null!==Va&&sb(a,"checked",Va);null!==Y?J(a,"value",Y):null!==Ta&&J(a,"value",Ta);a.push("/>");null!==tb&&tb.forEach(Eb,a);return null;case "button":a.push(N("button"));var qa=null,ra=null,ca=null,sa=null,ta=null,Wa=null,ua=null,Xa;for(Xa in c)if(y.call(c,Xa)){var da=c[Xa];if(null!=da)switch(Xa){case "children":qa=da;break;case "dangerouslySetInnerHTML":ra=
da;break;case "name":ca=da;break;case "formAction":sa=da;break;case "formEncType":ta=da;break;case "formMethod":Wa=da;break;case "formTarget":ua=da;break;default:J(a,Xa,da)}}var Xc=Fb(a,d,e,sa,ta,Wa,ua,ca);a.push(">");null!==Xc&&Xc.forEach(Eb,a);L(a,ra,qa);if("string"===typeof qa){a.push(z(qa));var Yc=null}else Yc=qa;return Yc;case "form":a.push(N("form"));var Ya=null,Zc=null,ja=null,Za=null,$a=null,ab=null,bb;for(bb in c)if(y.call(c,bb)){var ka=c[bb];if(null!=ka)switch(bb){case "children":Ya=ka;
break;case "dangerouslySetInnerHTML":Zc=ka;break;case "action":ja=ka;break;case "encType":Za=ka;break;case "method":$a=ka;break;case "target":ab=ka;break;default:J(a,bb,ka)}}var $b=null,ac=null;if("function"===typeof ja)if("function"===typeof ja.$$FORM_ACTION){var Le=Cb(d),Fa=ja.$$FORM_ACTION(Le);ja=Fa.action||"";Za=Fa.encType;$a=Fa.method;ab=Fa.target;$b=Fa.data;ac=Fa.name}else a.push(" ","action",'="',Db,'"'),ab=$a=Za=ja=null,Gb(d,e);null!=ja&&J(a,"action",ja);null!=Za&&J(a,"encType",Za);null!=
$a&&J(a,"method",$a);null!=ab&&J(a,"target",ab);a.push(">");null!==ac&&(a.push('<input type="hidden"'),I(a,"name",ac),a.push("/>"),null!==$b&&$b.forEach(Eb,a));L(a,Zc,Ya);if("string"===typeof Ya){a.push(z(Ya));var $c=null}else $c=Ya;return $c;case "menuitem":a.push(N("menuitem"));for(var ub in c)if(y.call(c,ub)){var ad=c[ub];if(null!=ad)switch(ub){case "children":case "dangerouslySetInnerHTML":throw Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");default:J(a,ub,ad)}}a.push(">");
return null;case "title":if(3===f.insertionMode||f.tagScope&1||null!=c.itemProp)var bd=Lb(a,c);else Lb(e.hoistableChunks,c),bd=null;return bd;case "link":return Ib(a,c,d,e,g,f.insertionMode,!!(f.tagScope&1));case "script":var bc=c.async;if("string"!==typeof c.src||!c.src||!bc||"function"===typeof bc||"symbol"===typeof bc||c.onLoad||c.onError||3===f.insertionMode||f.tagScope&1||null!=c.itemProp)var cd=Nb(a,c);else{var vb=c.src;if("module"===c.type){var wb=d.moduleScriptResources;var dd=e.preloads.moduleScripts}else wb=
d.scriptResources,dd=e.preloads.scripts;var xb=wb.hasOwnProperty(vb)?wb[vb]:void 0;if(null!==xb){wb[vb]=null;var cc=c;if(xb){2===xb.length&&(cc=v({},c),Jb(cc,xb));var ed=dd.get(vb);ed&&(ed.length=0)}var fd=[];e.scripts.add(fd);Nb(fd,cc)}g&&a.push("\x3c!-- --\x3e");cd=null}return cd;case "style":var yb=c.precedence,va=c.href;if(3===f.insertionMode||f.tagScope&1||null!=c.itemProp||"string"!==typeof yb||"string"!==typeof va||""===va){a.push(N("style"));var Ga=null,gd=null,cb;for(cb in c)if(y.call(c,
cb)){var zb=c[cb];if(null!=zb)switch(cb){case "children":Ga=zb;break;case "dangerouslySetInnerHTML":gd=zb;break;default:J(a,cb,zb)}}a.push(">");var db=Array.isArray(Ga)?2>Ga.length?Ga[0]:null:Ga;"function"!==typeof db&&"symbol"!==typeof db&&null!==db&&void 0!==db&&a.push(z(""+db));L(a,gd,Ga);a.push(Mb("style"));var hd=null}else{var wa=e.styles.get(yb);if(null!==(d.styleResources.hasOwnProperty(va)?d.styleResources[va]:void 0)){d.styleResources[va]=null;wa?wa.hrefs.push(z(va)):(wa={precedence:z(yb),
rules:[],hrefs:[z(va)],sheets:new Map},e.styles.set(yb,wa));var id=wa.rules,Ha=null,jd=null,Ab;for(Ab in c)if(y.call(c,Ab)){var dc=c[Ab];if(null!=dc)switch(Ab){case "children":Ha=dc;break;case "dangerouslySetInnerHTML":jd=dc}}var eb=Array.isArray(Ha)?2>Ha.length?Ha[0]:null:Ha;"function"!==typeof eb&&"symbol"!==typeof eb&&null!==eb&&void 0!==eb&&id.push(z(""+eb));L(id,jd,Ha)}wa&&e.boundaryResources&&e.boundaryResources.styles.add(wa);g&&a.push("\x3c!-- --\x3e");hd=void 0}return hd;case "meta":if(3===
f.insertionMode||f.tagScope&1||null!=c.itemProp)var kd=Kb(a,c,"meta");else g&&a.push("\x3c!-- --\x3e"),kd="string"===typeof c.charSet?Kb(e.charsetChunks,c,"meta"):"viewport"===c.name?Kb(e.preconnectChunks,c,"meta"):Kb(e.hoistableChunks,c,"meta");return kd;case "listing":case "pre":a.push(N(b));var fb=null,gb=null,hb;for(hb in c)if(y.call(c,hb)){var Bb=c[hb];if(null!=Bb)switch(hb){case "children":fb=Bb;break;case "dangerouslySetInnerHTML":gb=Bb;break;default:J(a,hb,Bb)}}a.push(">");if(null!=gb){if(null!=
fb)throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");if("object"!==typeof gb||!("__html"in gb))throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");var xa=gb.__html;null!==xa&&void 0!==xa&&("string"===typeof xa&&0<xa.length&&"\n"===xa[0]?a.push("\n",xa):a.push(""+xa))}"string"===typeof fb&&"\n"===fb[0]&&a.push("\n");return fb;case "img":var K=c.src,
H=c.srcSet;if(!("lazy"===c.loading||!K&&!H||"string"!==typeof K&&null!=K||"string"!==typeof H&&null!=H)&&"low"!==c.fetchPriority&&!1===!!(f.tagScope&2)&&("string"!==typeof K||":"!==K[4]||"d"!==K[0]&&"D"!==K[0]||"a"!==K[1]&&"A"!==K[1]||"t"!==K[2]&&"T"!==K[2]||"a"!==K[3]&&"A"!==K[3])&&("string"!==typeof H||":"!==H[4]||"d"!==H[0]&&"D"!==H[0]||"a"!==H[1]&&"A"!==H[1]||"t"!==H[2]&&"T"!==H[2]||"a"!==H[3]&&"A"!==H[3])){var ld="string"===typeof c.sizes?c.sizes:void 0,Ia=H?H+"\n"+(ld||""):K,ec=e.preloads.images,
ya=ec.get(Ia);if(ya){if("high"===c.fetchPriority||10>e.highImagePreloads.size)ec.delete(Ia),e.highImagePreloads.add(ya)}else if(!d.imageResources.hasOwnProperty(Ia)){d.imageResources[Ia]=B;var fc=c.crossOrigin;var md="string"===typeof fc?"use-credentials"===fc?fc:"":void 0;var Z=e.headers,gc;Z&&0<Z.remainingCapacity&&("high"===c.fetchPriority||500>Z.highImagePreloads.length)&&(gc=Sb(K,"image",{imageSrcSet:c.srcSet,imageSizes:c.sizes,crossOrigin:md,integrity:c.integrity,nonce:c.nonce,type:c.type,fetchPriority:c.fetchPriority,
referrerPolicy:c.refererPolicy}),2<=(Z.remainingCapacity-=gc.length))?(e.resets.image[Ia]=B,Z.highImagePreloads&&(Z.highImagePreloads+=", "),Z.highImagePreloads+=gc):(ya=[],M(ya,{rel:"preload",as:"image",href:H?void 0:K,imageSrcSet:H,imageSizes:ld,crossOrigin:md,integrity:c.integrity,type:c.type,fetchPriority:c.fetchPriority,referrerPolicy:c.referrerPolicy}),"high"===c.fetchPriority||10>e.highImagePreloads.size?e.highImagePreloads.add(ya):(e.bulkPreloads.add(ya),ec.set(Ia,ya)))}}return Kb(a,c,"img");
case "base":case "area":case "br":case "col":case "embed":case "hr":case "keygen":case "param":case "source":case "track":case "wbr":return Kb(a,c,b);case "annotation-xml":case "color-profile":case "font-face":case "font-face-src":case "font-face-uri":case "font-face-format":case "font-face-name":case "missing-glyph":break;case "head":if(2>f.insertionMode&&null===e.headChunks){e.headChunks=[];var nd=Ob(e.headChunks,c,"head")}else nd=Ob(a,c,"head");return nd;case "html":if(0===f.insertionMode&&null===
e.htmlChunks){e.htmlChunks=[""];var od=Ob(e.htmlChunks,c,"html")}else od=Ob(a,c,"html");return od;default:if(-1!==b.indexOf("-")){a.push(N(b));var hc=null,pd=null,Ja;for(Ja in c)if(y.call(c,Ja)){var U=c[Ja];if(null!=U){var qd=Ja;switch(Ja){case "children":hc=U;break;case "dangerouslySetInnerHTML":pd=U;break;case "style":rb(a,U);break;case "suppressContentEditableWarning":case "suppressHydrationWarning":break;case "className":qd="class";default:if(za(Ja)&&"function"!==typeof U&&"symbol"!==typeof U&&
!1!==U){if(!0===U)U="";else if("object"===typeof U)continue;a.push(" ",qd,'="',z(U),'"')}}}}a.push(">");L(a,pd,hc);return hc}}return Ob(a,c,b)}var Tb=new Map;function Mb(a){var b=Tb.get(a);void 0===b&&(b="</"+a+">",Tb.set(a,b));return b}function Ub(a,b){b=b.bootstrapChunks;for(var c=0;c<b.length-1;c++)a.push(b[c]);return c<b.length?(c=b[c],b.length=0,a.push(c)):!0}
function Vb(a,b,c){a.push('\x3c!--$?--\x3e<template id="');if(null===c)throw Error("An ID must have been assigned before we can complete the boundary.");a.push(b.boundaryPrefix);b=c.toString(16);a.push(b);return a.push('"></template>')}
function Wb(a,b,c,d){switch(c.insertionMode){case 0:case 1:case 2:return a.push('<div hidden id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 3:return a.push('<svg aria-hidden="true" style="display:none" id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 4:return a.push('<math aria-hidden="true" style="display:none" id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 5:return a.push('<table hidden id="'),a.push(b.segmentPrefix),
b=d.toString(16),a.push(b),a.push('">');case 6:return a.push('<table hidden><tbody id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 7:return a.push('<table hidden><tr id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 8:return a.push('<table hidden><colgroup id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');default:throw Error("Unknown insertion mode. This is a bug in React.");}}
function Xb(a,b){switch(b.insertionMode){case 0:case 1:case 2:return a.push("</div>");case 3:return a.push("</svg>");case 4:return a.push("</math>");case 5:return a.push("</table>");case 6:return a.push("</tbody></table>");case 7:return a.push("</tr></table>");case 8:return a.push("</colgroup></table>");default:throw Error("Unknown insertion mode. This is a bug in React.");}}var Yb=/[<\u2028\u2029]/g;
function Zb(a){return JSON.stringify(a).replace(Yb,function(b){switch(b){case "<":return"\\u003c";case "\u2028":return"\\u2028";case "\u2029":return"\\u2029";default:throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}})}var ic=/[&><\u2028\u2029]/g;
function jc(a){return JSON.stringify(a).replace(ic,function(b){switch(b){case "&":return"\\u0026";case ">":return"\\u003e";case "<":return"\\u003c";case "\u2028":return"\\u2028";case "\u2029":return"\\u2029";default:throw Error("escapeJSObjectForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}})}var kc=!1,lc=!0;
function mc(a){var b=a.rules,c=a.hrefs,d=0;if(c.length){this.push('<style media="not all" data-precedence="');this.push(a.precedence);for(this.push('" data-href="');d<c.length-1;d++)this.push(c[d]),this.push(" ");this.push(c[d]);this.push('">');for(d=0;d<b.length;d++)this.push(b[d]);lc=this.push("</style>");kc=!0;b.length=0;c.length=0}}function nc(a){return 2!==a.state?kc=!0:!1}function oc(a,b,c){kc=!1;lc=!0;b.styles.forEach(mc,a);b.stylesheets.forEach(nc);kc&&(c.stylesToHoist=!0);return lc}
function Q(a){for(var b=0;b<a.length;b++)this.push(a[b]);a.length=0}var pc=[];function qc(a){M(pc,a.props);for(var b=0;b<pc.length;b++)this.push(pc[b]);pc.length=0;a.state=2}
function rc(a){var b=0<a.sheets.size;a.sheets.forEach(qc,this);a.sheets.clear();var c=a.rules,d=a.hrefs;if(!b||d.length){this.push('<style data-precedence="');this.push(a.precedence);a=0;if(d.length){for(this.push('" data-href="');a<d.length-1;a++)this.push(d[a]),this.push(" ");this.push(d[a])}this.push('">');for(a=0;a<c.length;a++)this.push(c[a]);this.push("</style>");c.length=0;d.length=0}}
function sc(a){if(0===a.state){a.state=1;var b=a.props;M(pc,{rel:"preload",as:"style",href:a.props.href,crossOrigin:b.crossOrigin,fetchPriority:b.fetchPriority,integrity:b.integrity,media:b.media,hrefLang:b.hrefLang,referrerPolicy:b.referrerPolicy});for(a=0;a<pc.length;a++)this.push(pc[a]);pc.length=0}}function tc(a){a.sheets.forEach(sc,this);a.sheets.clear()}
function uc(a,b){a.push("[");var c="[";b.stylesheets.forEach(function(d){if(2!==d.state)if(3===d.state)a.push(c),d=jc(""+d.props.href),a.push(d),a.push("]"),c=",[";else{a.push(c);var e=d.props["data-precedence"],f=d.props,g=jc(""+d.props.href);a.push(g);e=""+e;a.push(",");e=jc(e);a.push(e);for(var h in f)if(y.call(f,h)&&(g=f[h],null!=g))switch(h){case "href":case "rel":case "precedence":case "data-precedence":break;case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
default:a:{e=a;var k=h.toLowerCase();switch(typeof g){case "function":case "symbol":break a}switch(h){case "innerHTML":case "dangerouslySetInnerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":case "style":break a;case "className":k="class";g=""+g;break;case "hidden":if(!1===g)break a;g="";break;case "src":case "href":g=""+g;break;default:if(2<h.length&&("o"===h[0]||"O"===h[0])&&("n"===h[1]||"N"===h[1])||!za(h))break a;g=""+g}e.push(",");k=jc(k);e.push(k);e.push(",");g=
jc(g);e.push(g)}}a.push("]");c=",[";d.state=3}});a.push("]")}
function vc(a,b){a.push("[");var c="[";b.stylesheets.forEach(function(d){if(2!==d.state)if(3===d.state)a.push(c),d=z(JSON.stringify(""+d.props.href)),a.push(d),a.push("]"),c=",[";else{a.push(c);var e=d.props["data-precedence"],f=d.props,g=z(JSON.stringify(""+d.props.href));a.push(g);e=""+e;a.push(",");e=z(JSON.stringify(e));a.push(e);for(var h in f)if(y.call(f,h)&&(g=f[h],null!=g))switch(h){case "href":case "rel":case "precedence":case "data-precedence":break;case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
default:a:{e=a;var k=h.toLowerCase();switch(typeof g){case "function":case "symbol":break a}switch(h){case "innerHTML":case "dangerouslySetInnerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":case "style":break a;case "className":k="class";g=""+g;break;case "hidden":if(!1===g)break a;g="";break;case "src":case "href":g=""+g;break;default:if(2<h.length&&("o"===h[0]||"O"===h[0])&&("n"===h[1]||"N"===h[1])||!za(h))break a;g=""+g}e.push(",");k=z(JSON.stringify(k));e.push(k);
e.push(",");g=z(JSON.stringify(g));e.push(g)}}a.push("]");c=",[";d.state=3}});a.push("]")}
function Oa(a){var b=T?T:null;if(b){var c=b.resumableState,d=b.renderState;if("string"===typeof a&&a){if(!c.dnsResources.hasOwnProperty(a)){c.dnsResources[a]=null;c=d.headers;var e,f;if(f=c&&0<c.remainingCapacity)f=(e="<"+(""+a).replace(wc,xc)+">; rel=dns-prefetch",2<=(c.remainingCapacity-=e.length));f?(d.resets.dns[a]=null,c.preconnects&&(c.preconnects+=", "),c.preconnects+=e):(e=[],M(e,{href:a,rel:"dns-prefetch"}),d.preconnects.add(e))}yc(b)}}}
function Pa(a,b){var c=T?T:null;if(c){var d=c.resumableState,e=c.renderState;if("string"===typeof a&&a){var f="use-credentials"===b?"credentials":"string"===typeof b?"anonymous":"default";if(!d.connectResources[f].hasOwnProperty(a)){d.connectResources[f][a]=null;d=e.headers;var g,h;if(h=d&&0<d.remainingCapacity){h="<"+(""+a).replace(wc,xc)+">; rel=preconnect";if("string"===typeof b){var k=(""+b).replace(zc,Ac);h+='; crossorigin="'+k+'"'}h=(g=h,2<=(d.remainingCapacity-=g.length))}h?(e.resets.connect[f][a]=
null,d.preconnects&&(d.preconnects+=", "),d.preconnects+=g):(f=[],M(f,{rel:"preconnect",href:a,crossOrigin:b}),e.preconnects.add(f))}yc(c)}}}
function Qa(a,b,c){var d=T?T:null;if(d){var e=d.resumableState,f=d.renderState;if(b&&a){switch(b){case "image":if(c){var g=c.imageSrcSet;var h=c.imageSizes;var k=c.fetchPriority}var l=g?g+"\n"+(h||""):a;if(e.imageResources.hasOwnProperty(l))return;e.imageResources[l]=B;e=f.headers;var m;e&&0<e.remainingCapacity&&"high"===k&&(m=Sb(a,b,c),2<=(e.remainingCapacity-=m.length))?(f.resets.image[l]=B,e.highImagePreloads&&(e.highImagePreloads+=", "),e.highImagePreloads+=m):(e=[],M(e,v({rel:"preload",href:g?
void 0:a,as:b},c)),"high"===k?f.highImagePreloads.add(e):(f.bulkPreloads.add(e),f.preloads.images.set(l,e)));break;case "style":if(e.styleResources.hasOwnProperty(a))return;g=[];M(g,v({rel:"preload",href:a,as:b},c));e.styleResources[a]=!c||"string"!==typeof c.crossOrigin&&"string"!==typeof c.integrity?B:[c.crossOrigin,c.integrity];f.preloads.stylesheets.set(a,g);f.bulkPreloads.add(g);break;case "script":if(e.scriptResources.hasOwnProperty(a))return;g=[];f.preloads.scripts.set(a,g);f.bulkPreloads.add(g);
M(g,v({rel:"preload",href:a,as:b},c));e.scriptResources[a]=!c||"string"!==typeof c.crossOrigin&&"string"!==typeof c.integrity?B:[c.crossOrigin,c.integrity];break;default:if(e.unknownResources.hasOwnProperty(b)){if(g=e.unknownResources[b],g.hasOwnProperty(a))return}else g={},e.unknownResources[b]=g;g[a]=B;if((e=f.headers)&&0<e.remainingCapacity&&"font"===b&&(l=Sb(a,b,c),2<=(e.remainingCapacity-=l.length)))f.resets.font[a]=B,e.fontPreloads&&(e.fontPreloads+=", "),e.fontPreloads+=l;else switch(e=[],
a=v({rel:"preload",href:a,as:b},c),M(e,a),b){case "font":f.fontPreloads.add(e);break;default:f.bulkPreloads.add(e)}}yc(d)}}}
function Ra(a,b){var c=T?T:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=b&&"string"===typeof b.as?b.as:"script";switch(f){case "script":if(d.moduleScriptResources.hasOwnProperty(a))return;f=[];d.moduleScriptResources[a]=!b||"string"!==typeof b.crossOrigin&&"string"!==typeof b.integrity?B:[b.crossOrigin,b.integrity];e.preloads.moduleScripts.set(a,f);break;default:if(d.moduleUnknownResources.hasOwnProperty(f)){var g=d.unknownResources[f];if(g.hasOwnProperty(a))return}else g={},d.moduleUnknownResources[f]=
g;f=[];g[a]=B}M(f,v({rel:"modulepreload",href:a},b));e.bulkPreloads.add(f);yc(c)}}}
function Sa(a,b,c){var d=T?T:null;if(d){var e=d.resumableState,f=d.renderState;if(a){b=b||"default";var g=f.styles.get(b),h=e.styleResources.hasOwnProperty(a)?e.styleResources[a]:void 0;null!==h&&(e.styleResources[a]=null,g||(g={precedence:z(b),rules:[],hrefs:[],sheets:new Map},f.styles.set(b,g)),b={state:0,props:v({rel:"stylesheet",href:a,"data-precedence":b},c)},h&&(2===h.length&&Jb(b.props,h),(f=f.preloads.stylesheets.get(a))&&0<f.length?f.length=0:b.state=1),g.sheets.set(a,b),yc(d))}}}
function ib(a,b){var c=T?T:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=d.scriptResources.hasOwnProperty(a)?d.scriptResources[a]:void 0;null!==f&&(d.scriptResources[a]=null,b=v({src:a,async:!0},b),f&&(2===f.length&&Jb(b,f),a=e.preloads.scripts.get(a))&&(a.length=0),a=[],e.scripts.add(a),Nb(a,b),yc(c))}}}
function jb(a,b){var c=T?T:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=d.moduleScriptResources.hasOwnProperty(a)?d.moduleScriptResources[a]:void 0;null!==f&&(d.moduleScriptResources[a]=null,b=v({src:a,type:"module",async:!0},b),f&&(2===f.length&&Jb(b,f),a=e.preloads.moduleScripts.get(a))&&(a.length=0),a=[],e.scripts.add(a),Nb(a,b),yc(c))}}}function Jb(a,b){null==a.crossOrigin&&(a.crossOrigin=b[0]);null==a.integrity&&(a.integrity=b[1])}
function Sb(a,b,c){a=(""+a).replace(wc,xc);b=(""+b).replace(zc,Ac);b="<"+a+'>; rel=preload; as="'+b+'"';for(var d in c)y.call(c,d)&&(a=c[d],"string"===typeof a&&(b+="; "+d.toLowerCase()+'="'+(""+a).replace(zc,Ac)+'"'));return b}var wc=/[<>\r\n]/g;
function xc(a){switch(a){case "<":return"%3C";case ">":return"%3E";case "\n":return"%0A";case "\r":return"%0D";default:throw Error("escapeLinkHrefForHeaderContextReplacer encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}}var zc=/["';,\r\n]/g;
function Ac(a){switch(a){case '"':return"%22";case "'":return"%27";case ";":return"%3B";case ",":return"%2C";case "\n":return"%0A";case "\r":return"%0D";default:throw Error("escapeStringForLinkHeaderQuotedParamValueContextReplacer encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}}function Bc(a){this.styles.add(a)}function Cc(a){this.stylesheets.add(a)}
function Dc(a,b){var c=a.idPrefix,d=[],e=a.bootstrapScriptContent,f=a.bootstrapScripts,g=a.bootstrapModules;void 0!==e&&d.push("<script>",(""+e).replace(lb,mb),"\x3c/script>");e=c+"P:";var h=c+"S:";c+="B:";var k=new Set,l=new Set,m=new Set,p=new Map,n=new Set,q=new Set,C=new Set,A={images:new Map,stylesheets:new Map,scripts:new Map,moduleScripts:new Map};if(void 0!==f)for(var x=0;x<f.length;x++){var u=f[x],t,E=void 0,w=void 0,r={rel:"preload",as:"script",fetchPriority:"low",nonce:void 0};"string"===
typeof u?r.href=t=u:(r.href=t=u.src,r.integrity=w="string"===typeof u.integrity?u.integrity:void 0,r.crossOrigin=E="string"===typeof u||null==u.crossOrigin?void 0:"use-credentials"===u.crossOrigin?"use-credentials":"");u=a;var D=t;u.scriptResources[D]=null;u.moduleScriptResources[D]=null;u=[];M(u,r);n.add(u);d.push('<script src="',z(t));"string"===typeof w&&d.push('" integrity="',z(w));"string"===typeof E&&d.push('" crossorigin="',z(E));d.push('" async="">\x3c/script>')}if(void 0!==g)for(f=0;f<g.length;f++)r=
g[f],E=t=void 0,w={rel:"modulepreload",fetchPriority:"low",nonce:void 0},"string"===typeof r?w.href=x=r:(w.href=x=r.src,w.integrity=E="string"===typeof r.integrity?r.integrity:void 0,w.crossOrigin=t="string"===typeof r||null==r.crossOrigin?void 0:"use-credentials"===r.crossOrigin?"use-credentials":""),r=a,u=x,r.scriptResources[u]=null,r.moduleScriptResources[u]=null,r=[],M(r,w),n.add(r),d.push('<script type="module" src="',z(x)),"string"===typeof E&&d.push('" integrity="',z(E)),"string"===typeof t&&
d.push('" crossorigin="',z(t)),d.push('" async="">\x3c/script>');return{placeholderPrefix:e,segmentPrefix:h,boundaryPrefix:c,startInlineScript:"<script>",htmlChunks:null,headChunks:null,externalRuntimeScript:null,bootstrapChunks:d,onHeaders:void 0,headers:null,resets:{font:{},dns:{},connect:{default:{},anonymous:{},credentials:{}},image:{},style:{}},charsetChunks:[],preconnectChunks:[],importMapChunks:[],preloadChunks:[],hoistableChunks:[],preconnects:k,fontPreloads:l,highImagePreloads:m,styles:p,
bootstrapScripts:n,scripts:q,bulkPreloads:C,preloads:A,boundaryResources:null,stylesToHoist:!1,generateStaticMarkup:b}}function Ec(a,b,c,d){if(c.generateStaticMarkup)return a.push(z(b)),!1;""===b?a=d:(d&&a.push("\x3c!-- --\x3e"),a.push(z(b)),a=!0);return a}
var Fc=Symbol.for("react.element"),Gc=Symbol.for("react.portal"),Hc=Symbol.for("react.fragment"),Ic=Symbol.for("react.strict_mode"),Jc=Symbol.for("react.profiler"),Kc=Symbol.for("react.provider"),Lc=Symbol.for("react.context"),Mc=Symbol.for("react.server_context"),Nc=Symbol.for("react.forward_ref"),Oc=Symbol.for("react.suspense"),Pc=Symbol.for("react.suspense_list"),Qc=Symbol.for("react.memo"),Rc=Symbol.for("react.lazy"),Sc=Symbol.for("react.scope"),Tc=Symbol.for("react.debug_trace_mode"),Uc=Symbol.for("react.offscreen"),
Vc=Symbol.for("react.legacy_hidden"),Wc=Symbol.for("react.cache"),rd=Symbol.for("react.default_value"),sd=Symbol.for("react.memo_cache_sentinel"),td=Symbol.for("react.postpone"),ud=Symbol.iterator,vd=Symbol.for("react.client.reference");
function wd(a){if(null==a)return null;if("function"===typeof a)return a.$$typeof===vd?null:a.displayName||a.name||null;if("string"===typeof a)return a;switch(a){case Hc:return"Fragment";case Gc:return"Portal";case Jc:return"Profiler";case Ic:return"StrictMode";case Oc:return"Suspense";case Pc:return"SuspenseList";case Wc:return"Cache"}if("object"===typeof a)switch(a.$$typeof){case Lc:return(a.displayName||"Context")+".Consumer";case Kc:return(a._context.displayName||"Context")+".Provider";case Nc:var b=
a.render;a=a.displayName;a||(a=b.displayName||b.name||"",a=""!==a?"ForwardRef("+a+")":"ForwardRef");return a;case Qc:return b=a.displayName||null,null!==b?b:wd(a.type)||"Memo";case Rc:b=a._payload;a=a._init;try{return wd(a(b))}catch(c){break}case Mc:return(a.displayName||a._globalName)+".Provider"}return null}var xd;function yd(a){if(void 0===xd)try{throw Error();}catch(c){var b=c.stack.trim().match(/\n( *(at )?)/);xd=b&&b[1]||""}return"\n"+xd+a}var zd=!1;
function Ad(a,b){if(!a||zd)return"";zd=!0;var c=Error.prepareStackTrace;Error.prepareStackTrace=void 0;var d={DetermineComponentFrameRoot:function(){try{if(b){var p=function(){throw Error();};Object.defineProperty(p.prototype,"props",{set:function(){throw Error();}});if("object"===typeof Reflect&&Reflect.construct){try{Reflect.construct(p,[])}catch(q){var n=q}Reflect.construct(a,[],p)}else{try{p.call()}catch(q){n=q}a.call(p.prototype)}}else{try{throw Error();}catch(q){n=q}(p=a())&&"function"===typeof p.catch&&
p.catch(function(){})}}catch(q){if(q&&n&&"string"===typeof q.stack)return[q.stack,n.stack]}return[null,null]}};d.DetermineComponentFrameRoot.displayName="DetermineComponentFrameRoot";var e=Object.getOwnPropertyDescriptor(d.DetermineComponentFrameRoot,"name");e&&e.configurable&&Object.defineProperty(d.DetermineComponentFrameRoot,"name",{value:"DetermineComponentFrameRoot"});try{var f=d.DetermineComponentFrameRoot(),g=f[0],h=f[1];if(g&&h){var k=g.split("\n"),l=h.split("\n");for(e=d=0;d<k.length&&!k[d].includes("DetermineComponentFrameRoot");)d++;
for(;e<l.length&&!l[e].includes("DetermineComponentFrameRoot");)e++;if(d===k.length||e===l.length)for(d=k.length-1,e=l.length-1;1<=d&&0<=e&&k[d]!==l[e];)e--;for(;1<=d&&0<=e;d--,e--)if(k[d]!==l[e]){if(1!==d||1!==e){do if(d--,e--,0>e||k[d]!==l[e]){var m="\n"+k[d].replace(" at new "," at ");a.displayName&&m.includes("<anonymous>")&&(m=m.replace("<anonymous>",a.displayName));return m}while(1<=d&&0<=e)}break}}}finally{zd=!1,Error.prepareStackTrace=c}return(c=a?a.displayName||a.name:"")?yd(c):""}
var Bd={};function Cd(a,b){a=a.contextTypes;if(!a)return Bd;var c={},d;for(d in a)c[d]=b[d];return c}var Dd=null;function Ed(a,b){if(a!==b){a.context._currentValue2=a.parentValue;a=a.parent;var c=b.parent;if(null===a){if(null!==c)throw Error("The stacks must reach the root at the same time. This is a bug in React.");}else{if(null===c)throw Error("The stacks must reach the root at the same time. This is a bug in React.");Ed(a,c)}b.context._currentValue2=b.value}}
function Fd(a){a.context._currentValue2=a.parentValue;a=a.parent;null!==a&&Fd(a)}function Gd(a){var b=a.parent;null!==b&&Gd(b);a.context._currentValue2=a.value}function Hd(a,b){a.context._currentValue2=a.parentValue;a=a.parent;if(null===a)throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");a.depth===b.depth?Ed(a,b):Hd(a,b)}
function Id(a,b){var c=b.parent;if(null===c)throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");a.depth===c.depth?Ed(a,c):Id(a,c);b.context._currentValue2=b.value}function Jd(a){var b=Dd;b!==a&&(null===b?Gd(a):null===a?Fd(b):b.depth===a.depth?Ed(b,a):b.depth>a.depth?Hd(b,a):Id(b,a),Dd=a)}
var Kd={isMounted:function(){return!1},enqueueSetState:function(a,b){a=a._reactInternals;null!==a.queue&&a.queue.push(b)},enqueueReplaceState:function(a,b){a=a._reactInternals;a.replace=!0;a.queue=[b]},enqueueForceUpdate:function(){}};
function Ld(a,b,c,d){var e=void 0!==a.state?a.state:null;a.updater=Kd;a.props=c;a.state=e;var f={queue:[],replace:!1};a._reactInternals=f;var g=b.contextType;a.context="object"===typeof g&&null!==g?g._currentValue2:d;g=b.getDerivedStateFromProps;"function"===typeof g&&(g=g(c,e),e=null===g||void 0===g?e:v({},e,g),a.state=e);if("function"!==typeof b.getDerivedStateFromProps&&"function"!==typeof a.getSnapshotBeforeUpdate&&("function"===typeof a.UNSAFE_componentWillMount||"function"===typeof a.componentWillMount))if(b=
a.state,"function"===typeof a.componentWillMount&&a.componentWillMount(),"function"===typeof a.UNSAFE_componentWillMount&&a.UNSAFE_componentWillMount(),b!==a.state&&Kd.enqueueReplaceState(a,a.state,null),null!==f.queue&&0<f.queue.length)if(b=f.queue,g=f.replace,f.queue=null,f.replace=!1,g&&1===b.length)a.state=b[0];else{f=g?b[0]:a.state;e=!0;for(g=g?1:0;g<b.length;g++){var h=b[g];h="function"===typeof h?h.call(a,f,c,d):h;null!=h&&(e?(e=!1,f=v({},f,h)):v(f,h))}a.state=f}else f.queue=null}
var Md={id:1,overflow:""};function Nd(a,b,c){var d=a.id;a=a.overflow;var e=32-Od(d)-1;d&=~(1<<e);c+=1;var f=32-Od(b)+e;if(30<f){var g=e-e%5;f=(d&(1<<g)-1).toString(32);d>>=g;e-=g;return{id:1<<32-Od(b)+e|c<<e|d,overflow:f+a}}return{id:1<<f|c<<e|d,overflow:a}}var Od=Math.clz32?Math.clz32:Pd,Qd=Math.log,Rd=Math.LN2;function Pd(a){a>>>=0;return 0===a?32:31-(Qd(a)/Rd|0)|0}var Sd=Error("Suspense Exception: This is not a real error! It's an implementation detail of `use` to interrupt the current render. You must either rethrow it immediately, or move the `use` call outside of the `try/catch` block. Capturing without rethrowing will lead to unexpected behavior.\n\nTo handle async errors, wrap your component in an error boundary, or call the promise's `.catch` method and pass the result to `use`");
function Td(){}function Ud(a,b,c){c=a[c];void 0===c?a.push(b):c!==b&&(b.then(Td,Td),b=c);switch(b.status){case "fulfilled":return b.value;case "rejected":throw b.reason;default:if("string"!==typeof b.status)switch(a=b,a.status="pending",a.then(function(d){if("pending"===b.status){var e=b;e.status="fulfilled";e.value=d}},function(d){if("pending"===b.status){var e=b;e.status="rejected";e.reason=d}}),b.status){case "fulfilled":return b.value;case "rejected":throw b.reason;}Vd=b;throw Sd;}}var Vd=null;
function Wd(){if(null===Vd)throw Error("Expected a suspended thenable. This is a bug in React. Please file an issue.");var a=Vd;Vd=null;return a}function Xd(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var Yd="function"===typeof Object.is?Object.is:Xd,Zd=null,$d=null,ae=null,be=null,ce=null,V=null,de=!1,ee=!1,fe=0,ge=0,he=-1,ie=0,je=null,ke=null,le=0;
function me(){if(null===Zd)throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.");return Zd}
function ne(){if(0<le)throw Error("Rendered more hooks than during the previous render");return{memoizedState:null,queue:null,next:null}}function oe(){null===V?null===ce?(de=!1,ce=V=ne()):(de=!0,V=ce):null===V.next?(de=!1,V=V.next=ne()):(de=!0,V=V.next);return V}function pe(a,b,c,d){for(;ee;)ee=!1,ge=fe=0,he=-1,ie=0,le+=1,V=null,c=a(b,d);qe();return c}function re(){var a=je;je=null;return a}function qe(){be=ae=$d=Zd=null;ee=!1;ce=null;le=0;V=ke=null}
function se(a,b){return"function"===typeof b?b(a):b}function te(a,b,c){Zd=me();V=oe();if(de){var d=V.queue;b=d.dispatch;if(null!==ke&&(c=ke.get(d),void 0!==c)){ke.delete(d);d=V.memoizedState;do d=a(d,c.action),c=c.next;while(null!==c);V.memoizedState=d;return[d,b]}return[V.memoizedState,b]}a=a===se?"function"===typeof b?b():b:void 0!==c?c(b):b;V.memoizedState=a;a=V.queue={last:null,dispatch:null};a=a.dispatch=ue.bind(null,Zd,a);return[V.memoizedState,a]}
function ve(a,b){Zd=me();V=oe();b=void 0===b?null:b;if(null!==V){var c=V.memoizedState;if(null!==c&&null!==b){var d=c[1];a:if(null===d)d=!1;else{for(var e=0;e<d.length&&e<b.length;e++)if(!Yd(b[e],d[e])){d=!1;break a}d=!0}if(d)return c[0]}}a=a();V.memoizedState=[a,b];return a}
function ue(a,b,c){if(25<=le)throw Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");if(a===Zd)if(ee=!0,a={action:c,next:null},null===ke&&(ke=new Map),c=ke.get(b),void 0===c)ke.set(b,a);else{for(b=c;null!==b.next;)b=b.next;b.next=a}}function we(){throw Error("A function wrapped in useEffectEvent can't be called during rendering.");}function xe(){throw Error("startTransition cannot be called during server rendering.");}
function ye(){throw Error("Cannot update optimistic state while rendering.");}function ze(a){var b=ie;ie+=1;null===je&&(je=[]);return Ud(je,a,b)}function Ae(){throw Error("Cache cannot be refreshed during server rendering.");}function Be(){}
var De={readContext:function(a){return a._currentValue2},use:function(a){if(null!==a&&"object"===typeof a){if("function"===typeof a.then)return ze(a);if(a.$$typeof===Lc||a.$$typeof===Mc)return a._currentValue2}throw Error("An unsupported type was passed to use(): "+String(a));},useContext:function(a){me();return a._currentValue2},useMemo:ve,useReducer:te,useRef:function(a){Zd=me();V=oe();var b=V.memoizedState;return null===b?(a={current:a},V.memoizedState=a):b},useState:function(a){return te(se,a)},
useInsertionEffect:Be,useLayoutEffect:Be,useCallback:function(a,b){return ve(function(){return a},b)},useImperativeHandle:Be,useEffect:Be,useDebugValue:Be,useDeferredValue:function(a,b){me();return void 0!==b?b:a},useTransition:function(){me();return[!1,xe]},useId:function(){var a=$d.treeContext;var b=a.overflow;a=a.id;a=(a&~(1<<32-Od(a)-1)).toString(32)+b;var c=Ce;if(null===c)throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");b=fe++;a=":"+c.idPrefix+
"R"+a;0<b&&(a+="H"+b.toString(32));return a+":"},useSyncExternalStore:function(a,b,c){if(void 0===c)throw Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");return c()},useCacheRefresh:function(){return Ae},useEffectEvent:function(){return we},useMemoCache:function(a){for(var b=Array(a),c=0;c<a;c++)b[c]=sd;return b},useHostTransitionStatus:function(){me();return Ma},useOptimistic:function(a){me();return[a,ye]},useFormState:function(a,
b,c){me();var d=ge++,e=ae;if("function"===typeof a.$$FORM_ACTION){var f=null,g=be;e=e.formState;var h=a.$$IS_SIGNATURE_EQUAL;if(null!==e&&"function"===typeof h){var k=e[1];h.call(a,e[2],e[3])&&(f=void 0!==c?"p"+c:"k"+fa(JSON.stringify([g,null,d]),0),k===f&&(he=d,b=e[0]))}var l=a.bind(null,b);a=function(p){l(p)};"function"===typeof l.$$FORM_ACTION&&(a.$$FORM_ACTION=function(p){p=l.$$FORM_ACTION(p);void 0!==c&&(c+="",p.action=c);var n=p.data;n&&(null===f&&(f=void 0!==c?"p"+c:"k"+fa(JSON.stringify([g,
null,d]),0)),n.append("$ACTION_KEY",f));return p});return[b,a]}var m=a.bind(null,b);return[b,function(p){m(p)}]}},Ce=null,Ee={getCacheSignal:function(){throw Error("Not implemented.");},getCacheForType:function(){throw Error("Not implemented.");}},Fe=La.ReactCurrentDispatcher,Ge=La.ReactCurrentCache;function He(a){console.error(a);return null}function Ie(){}
function Je(a,b,c,d,e,f,g,h,k,l,m,p){Na.current=kb;var n=[],q=new Set;b={destination:null,flushScheduled:!1,resumableState:b,renderState:c,rootFormatContext:d,progressiveChunkSize:void 0===e?12800:e,status:0,fatalError:null,nextSegmentId:0,allPendingTasks:0,pendingRootTasks:0,completedRootSegment:null,abortableTasks:q,pingedTasks:n,clientRenderedBoundaries:[],completedBoundaries:[],partialBoundaries:[],trackedPostpones:null,onError:void 0===f?He:f,onPostpone:void 0===m?Ie:m,onAllReady:void 0===g?
Ie:g,onShellReady:void 0===h?Ie:h,onShellError:void 0===k?Ie:k,onFatalError:void 0===l?Ie:l,formState:void 0===p?null:p};c=Ke(b,0,null,d,!1,!1);c.parentFlushed=!0;a=Me(b,null,a,-1,null,c,q,null,d,Bd,null,Md,null);n.push(a);return b}var T=null;function Ne(a,b){a.pingedTasks.push(b);1===a.pingedTasks.length&&(a.flushScheduled=null!==a.destination,Oe(a))}
function Pe(a,b){return{status:0,rootSegmentID:-1,parentFlushed:!1,pendingTasks:0,completedSegments:[],byteSize:0,fallbackAbortableTasks:b,errorDigest:null,resources:{styles:new Set,stylesheets:new Set},trackedContentKeyPath:null,trackedFallbackNode:null}}
function Me(a,b,c,d,e,f,g,h,k,l,m,p,n){a.allPendingTasks++;null===e?a.pendingRootTasks++:e.pendingTasks++;var q={replay:null,node:c,childIndex:d,ping:function(){return Ne(a,q)},blockedBoundary:e,blockedSegment:f,abortSet:g,keyPath:h,formatContext:k,legacyContext:l,context:m,treeContext:p,componentStack:n,thenableState:b};g.add(q);return q}
function Qe(a,b,c,d,e,f,g,h,k,l,m,p,n){a.allPendingTasks++;null===f?a.pendingRootTasks++:f.pendingTasks++;c.pendingTasks++;var q={replay:c,node:d,childIndex:e,ping:function(){return Ne(a,q)},blockedBoundary:f,blockedSegment:null,abortSet:g,keyPath:h,formatContext:k,legacyContext:l,context:m,treeContext:p,componentStack:n,thenableState:b};g.add(q);return q}
function Ke(a,b,c,d,e,f){return{status:0,id:-1,index:b,parentFlushed:!1,chunks:[],children:[],parentFormatContext:d,boundary:c,lastPushedText:e,textEmbedded:f}}function Re(a,b){return{tag:0,parent:a.componentStack,type:b}}
function Se(a,b){if(b&&null!==a.trackedPostpones){try{a="";do{switch(b.tag){case 0:a+=yd(b.type,null,null);break;case 1:a+=Ad(b.type,!1);break;case 2:a+=Ad(b.type,!0)}b=b.parent}while(b);var c=a}catch(d){c="\nError generating stack: "+d.message+"\n"+d.stack}c={componentStack:c}}else c={};return c}function W(a,b,c){a=a.onError(b,c);if(null==a||"string"===typeof a)return a}
function Te(a,b){var c=a.onShellError;c(b);c=a.onFatalError;c(b);null!==a.destination?(a.status=2,a.destination.destroy(b)):(a.status=1,a.fatalError=b)}
function Ue(a,b,c,d,e){var f=d.render(),g=e.childContextTypes;if(null!==g&&void 0!==g){c=b.legacyContext;if("function"!==typeof d.getChildContext)e=c;else{d=d.getChildContext();for(var h in d)if(!(h in g))throw Error((wd(e)||"Unknown")+'.getChildContext(): key "'+h+'" is not defined in childContextTypes.');e=v({},c,d)}b.legacyContext=e;X(a,b,null,f,-1);b.legacyContext=c}else e=b.keyPath,b.keyPath=c,X(a,b,null,f,-1),b.keyPath=e}
function Ve(a,b,c,d,e,f,g){var h=!1;if(0!==f&&null!==a.formState){var k=b.blockedSegment;if(null!==k){h=!0;k=k.chunks;for(var l=0;l<f;l++)l===g?k.push("\x3c!--F!--\x3e"):k.push("\x3c!--F--\x3e")}}f=b.keyPath;b.keyPath=c;e?(c=b.treeContext,b.treeContext=Nd(c,1,0),We(a,b,d,-1),b.treeContext=c):h?We(a,b,d,-1):X(a,b,null,d,-1);b.keyPath=f}function Xe(a,b){if(a&&a.defaultProps){b=v({},b);a=a.defaultProps;for(var c in a)void 0===b[c]&&(b[c]=a[c]);return b}return b}
function Ye(a,b,c,d,e,f,g){if("function"===typeof e)if(e.prototype&&e.prototype.isReactComponent){d=b.componentStack;b.componentStack={tag:2,parent:b.componentStack,type:e};g=Cd(e,b.legacyContext);var h=e.contextType;h=new e(f,"object"===typeof h&&null!==h?h._currentValue2:g);Ld(h,e,f,g);Ue(a,b,c,h,e);b.componentStack=d}else{g=Cd(e,b.legacyContext);h=b.componentStack;b.componentStack={tag:1,parent:b.componentStack,type:e};Zd={};$d=b;ae=a;be=c;ge=fe=0;he=-1;ie=0;je=d;d=e(f,g);d=pe(e,f,d,g);var k=0!==
fe,l=ge,m=he;"object"===typeof d&&null!==d&&"function"===typeof d.render&&void 0===d.$$typeof?(Ld(d,e,f,g),Ue(a,b,c,d,e)):Ve(a,b,c,d,k,l,m);b.componentStack=h}else if("string"===typeof e){d=b.componentStack;b.componentStack=Re(b,e);g=b.blockedSegment;if(null===g)g=f.children,h=b.formatContext,k=b.keyPath,b.formatContext=pb(h,e,f),b.keyPath=c,We(a,b,g,-1),b.formatContext=h,b.keyPath=k;else{k=Rb(g.chunks,e,f,a.resumableState,a.renderState,b.formatContext,g.lastPushedText);g.lastPushedText=!1;h=b.formatContext;
l=b.keyPath;b.formatContext=pb(h,e,f);b.keyPath=c;We(a,b,k,-1);b.formatContext=h;b.keyPath=l;a:{c=g.chunks;a=a.resumableState;switch(e){case "title":case "style":case "script":case "area":case "base":case "br":case "col":case "embed":case "hr":case "img":case "input":case "keygen":case "link":case "meta":case "param":case "source":case "track":case "wbr":break a;case "body":if(1>=h.insertionMode){a.hasBody=!0;break a}break;case "html":if(0===h.insertionMode){a.hasHtml=!0;break a}}c.push(Mb(e))}g.lastPushedText=
!1}b.componentStack=d}else{switch(e){case Vc:case Tc:case Ic:case Jc:case Hc:e=b.keyPath;b.keyPath=c;X(a,b,null,f.children,-1);b.keyPath=e;return;case Uc:"hidden"!==f.mode&&(e=b.keyPath,b.keyPath=c,X(a,b,null,f.children,-1),b.keyPath=e);return;case Pc:e=b.componentStack;b.componentStack=Re(b,"SuspenseList");d=b.keyPath;b.keyPath=c;X(a,b,null,f.children,-1);b.keyPath=d;b.componentStack=e;return;case Sc:throw Error("ReactDOMServer does not yet support scope components.");case Oc:a:if(null!==b.replay){e=
b.keyPath;b.keyPath=c;c=f.children;try{We(a,b,c,-1)}finally{b.keyPath=e}}else{var p=b.componentStack;e=b.componentStack=Re(b,"Suspense");var n=b.keyPath;d=b.blockedBoundary;var q=b.blockedSegment;g=f.fallback;var C=f.children;f=new Set;l=Pe(a,f);null!==a.trackedPostpones&&(l.trackedContentKeyPath=c);m=Ke(a,q.chunks.length,l,b.formatContext,!1,!1);q.children.push(m);q.lastPushedText=!1;var A=Ke(a,0,null,b.formatContext,!1,!1);A.parentFlushed=!0;b.blockedBoundary=l;b.blockedSegment=A;a.renderState.boundaryResources=
l.resources;b.keyPath=c;try{if(We(a,b,C,-1),a.renderState.generateStaticMarkup||A.lastPushedText&&A.textEmbedded&&A.chunks.push("\x3c!-- --\x3e"),A.status=1,Ze(l,A),0===l.pendingTasks&&0===l.status){l.status=1;b.componentStack=p;break a}}catch(x){A.status=4,l.status=4,h=Se(a,b.componentStack),"object"===typeof x&&null!==x&&x.$$typeof===td?(a.onPostpone(x.message,h),k="POSTPONE"):k=W(a,x,h),l.errorDigest=k,$e(a,l)}finally{a.renderState.boundaryResources=d?d.resources:null,b.blockedBoundary=d,b.blockedSegment=
q,b.keyPath=n,b.componentStack=p}h=[c[0],"Suspense Fallback",c[2]];k=a.trackedPostpones;null!==k&&(p=[h[1],h[2],[],null],k.workingMap.set(h,p),5===l.status?k.workingMap.get(c)[4]=p:l.trackedFallbackNode=p);b=Me(a,null,g,-1,d,m,f,h,b.formatContext,b.legacyContext,b.context,b.treeContext,e);a.pingedTasks.push(b)}return}if("object"===typeof e&&null!==e)switch(e.$$typeof){case Nc:h=b.componentStack;b.componentStack={tag:1,parent:b.componentStack,type:e.render};e=e.render;Zd={};$d=b;ae=a;be=c;ge=fe=0;
he=-1;ie=0;je=d;d=e(f,g);f=pe(e,f,d,g);Ve(a,b,c,f,0!==fe,ge,he);b.componentStack=h;return;case Qc:e=e.type;f=Xe(e,f);Ye(a,b,c,d,e,f,g);return;case Kc:g=f.children;d=b.keyPath;e=e._context;f=f.value;h=e._currentValue2;e._currentValue2=f;k=Dd;Dd=f={parent:k,depth:null===k?0:k.depth+1,context:e,parentValue:h,value:f};b.context=f;b.keyPath=c;X(a,b,null,g,-1);a=Dd;if(null===a)throw Error("Tried to pop a Context at the root of the app. This is a bug in React.");c=a.parentValue;a.context._currentValue2=
c===rd?a.context._defaultValue:c;a=Dd=a.parent;b.context=a;b.keyPath=d;return;case Lc:f=f.children;f=f(e._currentValue2);e=b.keyPath;b.keyPath=c;X(a,b,null,f,-1);b.keyPath=e;return;case Rc:g=b.componentStack;b.componentStack=Re(b,"Lazy");h=e._init;e=h(e._payload);f=Xe(e,f);Ye(a,b,c,d,e,f,void 0);b.componentStack=g;return}throw Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: "+((null==e?e:typeof e)+"."));}}
function af(a,b,c,d,e){var f=b.replay,g=b.blockedBoundary,h=Ke(a,0,null,b.formatContext,!1,!1);h.id=c;h.parentFlushed=!0;try{b.replay=null,b.blockedSegment=h,We(a,b,d,e),h.status=1,null===g?a.completedRootSegment=h:(Ze(g,h),g.parentFlushed&&a.partialBoundaries.push(g))}finally{b.replay=f,b.blockedSegment=null}}
function X(a,b,c,d,e){if(null!==b.replay&&"number"===typeof b.replay.slots)af(a,b,b.replay.slots,d,e);else{b.node=d;b.childIndex=e;if("object"===typeof d&&null!==d){switch(d.$$typeof){case Fc:var f=d.type,g=d.key,h=d.props,k=d.ref,l=wd(f),m=null==g?-1===e?0:e:g;g=[b.keyPath,l,m];if(null!==b.replay)a:{var p=b.replay;e=p.nodes;for(d=0;d<e.length;d++){var n=e[d];if(m===n[1]){if(4===n.length){if(null!==l&&l!==n[0])throw Error("Expected the resume to render <"+n[0]+"> in this slot but instead it rendered <"+
l+">. The tree doesn't match so React will fallback to client rendering.");var q=n[2];l=n[3];n=b.node;b.replay={nodes:q,slots:l,pendingTasks:1};try{Ye(a,b,g,c,f,h,k);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--}catch(r){if("object"===typeof r&&null!==r&&(r===Sd||"function"===typeof r.then))throw b.node===n&&(b.replay=p),
r;b.replay.pendingTasks--;h=Se(a,b.componentStack);bf(a,b.blockedBoundary,r,h,q,l)}b.replay=p}else{if(f!==Oc)throw Error("Expected the resume to render <Suspense> in this slot but instead it rendered <"+(wd(f)||"Unknown")+">. The tree doesn't match so React will fallback to client rendering.");b:{c=void 0;f=n[5];k=n[2];p=n[3];l=null===n[4]?[]:n[4][2];n=null===n[4]?null:n[4][3];m=b.componentStack;var C=b.componentStack=Re(b,"Suspense"),A=b.keyPath,x=b.replay,u=b.blockedBoundary,t=h.children;h=h.fallback;
var E=new Set,w=Pe(a,E);w.parentFlushed=!0;w.rootSegmentID=f;b.blockedBoundary=w;b.replay={nodes:k,slots:p,pendingTasks:1};a.renderState.boundaryResources=w.resources;try{We(a,b,t,-1);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--;if(0===w.pendingTasks&&0===w.status){w.status=1;a.completedBoundaries.push(w);break b}}catch(r){w.status=
4,q=Se(a,b.componentStack),"object"===typeof r&&null!==r&&r.$$typeof===td?(a.onPostpone(r.message,q),c="POSTPONE"):c=W(a,r,q),w.errorDigest=c,b.replay.pendingTasks--,a.clientRenderedBoundaries.push(w)}finally{a.renderState.boundaryResources=u?u.resources:null,b.blockedBoundary=u,b.replay=x,b.keyPath=A,b.componentStack=m}h=Qe(a,null,{nodes:l,slots:n,pendingTasks:0},h,-1,u,E,[g[0],"Suspense Fallback",g[2]],b.formatContext,b.legacyContext,b.context,b.treeContext,C);a.pingedTasks.push(h)}}e.splice(d,
1);break a}}}else Ye(a,b,g,c,f,h,k);return;case Gc:throw Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");case Rc:h=b.componentStack;b.componentStack=Re(b,"Lazy");g=d._init;d=g(d._payload);b.componentStack=h;X(a,b,null,d,e);return}if(Ka(d)){cf(a,b,d,e);return}null===d||"object"!==typeof d?h=null:(h=ud&&d[ud]||d["@@iterator"],h="function"===typeof h?h:null);if(h&&(h=h.call(d))){d=h.next();if(!d.done){g=[];
do g.push(d.value),d=h.next();while(!d.done);cf(a,b,g,e)}return}if("function"===typeof d.then)return X(a,b,null,ze(d),e);if(d.$$typeof===Lc||d.$$typeof===Mc)return X(a,b,null,d._currentValue2,e);e=Object.prototype.toString.call(d);throw Error("Objects are not valid as a React child (found: "+("[object Object]"===e?"object with keys {"+Object.keys(d).join(", ")+"}":e)+"). If you meant to render a collection of children, use an array instead.");}"string"===typeof d?(e=b.blockedSegment,null!==e&&(e.lastPushedText=
Ec(e.chunks,d,a.renderState,e.lastPushedText))):"number"===typeof d&&(e=b.blockedSegment,null!==e&&(e.lastPushedText=Ec(e.chunks,""+d,a.renderState,e.lastPushedText)))}}
function cf(a,b,c,d){var e=b.keyPath;if(-1!==d&&(b.keyPath=[b.keyPath,"Fragment",d],null!==b.replay)){for(var f=b.replay,g=f.nodes,h=0;h<g.length;h++){var k=g[h];if(k[1]===d){d=k[2];k=k[3];b.replay={nodes:d,slots:k,pendingTasks:1};try{cf(a,b,c,-1);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--}catch(m){if("object"===typeof m&&
null!==m&&(m===Sd||"function"===typeof m.then))throw m;b.replay.pendingTasks--;c=Se(a,b.componentStack);bf(a,b.blockedBoundary,m,c,d,k)}b.replay=f;g.splice(h,1);break}}b.keyPath=e;return}f=b.treeContext;g=c.length;if(null!==b.replay&&(h=b.replay.slots,null!==h&&"object"===typeof h)){for(d=0;d<g;d++){k=c[d];b.treeContext=Nd(f,g,d);var l=h[d];"number"===typeof l?(af(a,b,l,k,d),delete h[d]):We(a,b,k,d)}b.treeContext=f;b.keyPath=e;return}for(h=0;h<g;h++)d=c[h],b.treeContext=Nd(f,g,h),We(a,b,d,h);b.treeContext=
f;b.keyPath=e}
function df(a,b,c,d){d.status=5;var e=c.keyPath,f=c.blockedBoundary;if(null===f)d.id=a.nextSegmentId++,b.rootSlots=d.id,null!==a.completedRootSegment&&(a.completedRootSegment.status=5);else{if(null!==f&&0===f.status){f.status=5;f.rootSegmentID=a.nextSegmentId++;var g=f.trackedContentKeyPath;if(null===g)throw Error("It should not be possible to postpone at the root. This is a bug in React.");var h=f.trackedFallbackNode,k=[];if(g===e&&-1===c.childIndex){-1===d.id&&(d.id=d.parentFlushed?f.rootSegmentID:
a.nextSegmentId++);d=[g[1],g[2],k,d.id,h,f.rootSegmentID];b.workingMap.set(g,d);ef(d,g[0],b);return}var l=b.workingMap.get(g);void 0===l?(l=[g[1],g[2],k,null,h,f.rootSegmentID],b.workingMap.set(g,l),ef(l,g[0],b)):(g=l,g[4]=h,g[5]=f.rootSegmentID)}-1===d.id&&(d.id=d.parentFlushed&&null!==f?f.rootSegmentID:a.nextSegmentId++);if(-1===c.childIndex)null===e?b.rootSlots=d.id:(c=b.workingMap.get(e),void 0===c?(c=[e[1],e[2],[],d.id],ef(c,e[0],b)):c[3]=d.id);else{if(null===e)if(a=b.rootSlots,null===a)a=b.rootSlots=
{};else{if("number"===typeof a)throw Error("It should not be possible to postpone both at the root of an element as well as a slot below. This is a bug in React.");}else if(f=b.workingMap,g=f.get(e),void 0===g)a={},g=[e[1],e[2],[],a],f.set(e,g),ef(g,e[0],b);else if(a=g[3],null===a)a=g[3]={};else if("number"===typeof a)throw Error("It should not be possible to postpone both at the root of an element as well as a slot below. This is a bug in React.");a[c.childIndex]=d.id}}}
function $e(a,b){a=a.trackedPostpones;null!==a&&(b=b.trackedContentKeyPath,null!==b&&(b=a.workingMap.get(b),void 0!==b&&(b.length=4,b[2]=[],b[3]=null)))}
function We(a,b,c,d){var e=b.formatContext,f=b.legacyContext,g=b.context,h=b.keyPath,k=b.treeContext,l=b.componentStack,m=b.blockedSegment;if(null===m)try{return X(a,b,null,c,d)}catch(q){if(qe(),d=q===Sd?Wd():q,"object"===typeof d&&null!==d&&"function"===typeof d.then){c=d;d=re();a=Qe(a,d,b.replay,b.node,b.childIndex,b.blockedBoundary,b.abortSet,b.keyPath,b.formatContext,b.legacyContext,b.context,b.treeContext,null!==b.componentStack?b.componentStack.parent:null).ping;c.then(a,a);b.formatContext=
e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;b.componentStack=l;Jd(g);return}}else{var p=m.children.length,n=m.chunks.length;try{return X(a,b,null,c,d)}catch(q){if(qe(),m.children.length=p,m.chunks.length=n,d=q===Sd?Wd():q,"object"===typeof d&&null!==d){if("function"===typeof d.then){c=d;d=re();m=b.blockedSegment;p=Ke(a,m.chunks.length,null,b.formatContext,m.lastPushedText,!0);m.children.push(p);m.lastPushedText=!1;a=Me(a,d,b.node,b.childIndex,b.blockedBoundary,p,b.abortSet,b.keyPath,
b.formatContext,b.legacyContext,b.context,b.treeContext,null!==b.componentStack?b.componentStack.parent:null).ping;c.then(a,a);b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;b.componentStack=l;Jd(g);return}if(d.$$typeof===td&&null!==a.trackedPostpones&&null!==b.blockedBoundary){c=a.trackedPostpones;m=Se(a,b.componentStack);a.onPostpone(d.message,m);d=b.blockedSegment;m=Ke(a,d.chunks.length,null,b.formatContext,d.lastPushedText,!0);d.children.push(m);d.lastPushedText=!1;
df(a,c,b,m);b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;b.componentStack=l;Jd(g);return}}}}b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;Jd(g);throw d;}function bf(a,b,c,d,e,f){"object"===typeof c&&null!==c&&c.$$typeof===td?(a.onPostpone(c.message,d),d="POSTPONE"):d=W(a,c,d);ff(a,b,e,f,c,d)}function gf(a){var b=a.blockedBoundary;a=a.blockedSegment;null!==a&&(a.status=3,hf(this,b,a))}
function ff(a,b,c,d,e,f){for(var g=0;g<c.length;g++){var h=c[g];if(4===h.length)ff(a,b,h[2],h[3],e,f);else{h=h[5];var k=a,l=f,m=Pe(k,new Set);m.parentFlushed=!0;m.rootSegmentID=h;m.status=4;m.errorDigest=l;m.parentFlushed&&k.clientRenderedBoundaries.push(m)}}c.length=0;if(null!==d){if(null===b)throw Error("We should not have any resumable nodes in the shell. This is a bug in React.");4!==b.status&&(b.status=4,b.errorDigest=f,b.parentFlushed&&a.clientRenderedBoundaries.push(b));if("object"===typeof d)for(var p in d)delete d[p]}}
function jf(a,b,c){var d=a.blockedBoundary,e=a.blockedSegment;null!==e&&(e.status=3);if(null===d){if(d={},1!==b.status&&2!==b.status){a=a.replay;if(null===a){W(b,c,d);Te(b,c);return}a.pendingTasks--;0===a.pendingTasks&&0<a.nodes.length&&(d=W(b,c,d),ff(b,null,a.nodes,a.slots,c,d));b.pendingRootTasks--;0===b.pendingRootTasks&&kf(b)}}else d.pendingTasks--,4!==d.status&&(d.status=4,a=Se(b,a.componentStack),a=W(b,c,a),d.errorDigest=a,$e(b,d),d.parentFlushed&&b.clientRenderedBoundaries.push(d)),d.fallbackAbortableTasks.forEach(function(f){return jf(f,
b,c)}),d.fallbackAbortableTasks.clear();b.allPendingTasks--;0===b.allPendingTasks&&lf(b)}
function mf(a,b){try{var c=a.renderState,d=c.onHeaders;if(d){var e=c.headers;if(e){c.headers=null;var f=e.preconnects;e.fontPreloads&&(f&&(f+=", "),f+=e.fontPreloads);e.highImagePreloads&&(f&&(f+=", "),f+=e.highImagePreloads);if(!b){var g=c.styles.values(),h=g.next();b:for(;0<e.remainingCapacity&&!h.done;h=g.next())for(var k=h.value.sheets.values(),l=k.next();0<e.remainingCapacity&&!l.done;l=k.next()){var m=l.value,p=m.props,n=p.href,q=m.props,C=Sb(q.href,"style",{crossOrigin:q.crossOrigin,integrity:q.integrity,
nonce:q.nonce,type:q.type,fetchPriority:q.fetchPriority,referrerPolicy:q.referrerPolicy,media:q.media});if(2<=(e.remainingCapacity-=C.length))c.resets.style[n]=B,f&&(f+=", "),f+=C,c.resets.style[n]="string"===typeof p.crossOrigin||"string"===typeof p.integrity?[p.crossOrigin,p.integrity]:B;else break b}}f?d({Link:f}):d({})}}}catch(A){W(a,A,{})}}function kf(a){null===a.trackedPostpones&&mf(a,!0);a.onShellError=Ie;a=a.onShellReady;a()}
function lf(a){mf(a,null===a.trackedPostpones?!0:null===a.completedRootSegment||5!==a.completedRootSegment.status);a=a.onAllReady;a()}function Ze(a,b){if(0===b.chunks.length&&1===b.children.length&&null===b.children[0].boundary&&-1===b.children[0].id){var c=b.children[0];c.id=b.id;c.parentFlushed=!0;1===c.status&&Ze(a,c)}else a.completedSegments.push(b)}
function hf(a,b,c){if(null===b){if(null!==c&&c.parentFlushed){if(null!==a.completedRootSegment)throw Error("There can only be one root segment. This is a bug in React.");a.completedRootSegment=c}a.pendingRootTasks--;0===a.pendingRootTasks&&kf(a)}else b.pendingTasks--,4!==b.status&&(0===b.pendingTasks?(0===b.status&&(b.status=1),null!==c&&c.parentFlushed&&1===c.status&&Ze(b,c),b.parentFlushed&&a.completedBoundaries.push(b),1===b.status&&(b.fallbackAbortableTasks.forEach(gf,a),b.fallbackAbortableTasks.clear())):
null!==c&&c.parentFlushed&&1===c.status&&(Ze(b,c),1===b.completedSegments.length&&b.parentFlushed&&a.partialBoundaries.push(b)));a.allPendingTasks--;0===a.allPendingTasks&&lf(a)}
function Oe(a){if(2!==a.status){var b=Dd,c=Fe.current;Fe.current=De;var d=Ge.current;Ge.current=Ee;var e=T;T=a;var f=Ce;Ce=a.resumableState;try{var g=a.pingedTasks,h;for(h=0;h<g.length;h++){var k=g[h],l=a,m=k.blockedBoundary;l.renderState.boundaryResources=m?m.resources:null;var p=k.blockedSegment;if(null===p){var n=l;if(0!==k.replay.pendingTasks){Jd(k.context);try{var q=k.thenableState;k.thenableState=null;X(n,k,q,k.node,k.childIndex);if(1===k.replay.pendingTasks&&0<k.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");
k.replay.pendingTasks--;k.abortSet.delete(k);hf(n,k.blockedBoundary,null)}catch(P){qe();var C=P===Sd?Wd():P;if("object"===typeof C&&null!==C&&"function"===typeof C.then){var A=k.ping;C.then(A,A);k.thenableState=re()}else{k.replay.pendingTasks--;k.abortSet.delete(k);var x=Se(n,k.componentStack);bf(n,k.blockedBoundary,C,x,k.replay.nodes,k.replay.slots);n.pendingRootTasks--;0===n.pendingRootTasks&&kf(n);n.allPendingTasks--;0===n.allPendingTasks&&lf(n)}}finally{n.renderState.boundaryResources=null}}}else a:{n=
void 0;var u=p;if(0===u.status){Jd(k.context);var t=u.children.length,E=u.chunks.length;try{var w=k.thenableState;k.thenableState=null;X(l,k,w,k.node,k.childIndex);l.renderState.generateStaticMarkup||u.lastPushedText&&u.textEmbedded&&u.chunks.push("\x3c!-- --\x3e");k.abortSet.delete(k);u.status=1;hf(l,k.blockedBoundary,u)}catch(P){qe();u.children.length=t;u.chunks.length=E;var r=P===Sd?Wd():P;if("object"===typeof r&&null!==r){if("function"===typeof r.then){var D=k.ping;r.then(D,D);k.thenableState=
re();break a}if(null!==l.trackedPostpones&&r.$$typeof===td){var O=l.trackedPostpones;k.abortSet.delete(k);var F=Se(l,k.componentStack);l.onPostpone(r.message,F);df(l,O,k,u);hf(l,k.blockedBoundary,u);break a}}var ha=Se(l,k.componentStack);k.abortSet.delete(k);u.status=4;var R=k.blockedBoundary;"object"===typeof r&&null!==r&&r.$$typeof===td?(l.onPostpone(r.message,ha),n="POSTPONE"):n=W(l,r,ha);null===R?Te(l,r):(R.pendingTasks--,4!==R.status&&(R.status=4,R.errorDigest=n,$e(l,R),R.parentFlushed&&l.clientRenderedBoundaries.push(R)));
l.allPendingTasks--;0===l.allPendingTasks&&lf(l)}finally{l.renderState.boundaryResources=null}}}}g.splice(0,h);null!==a.destination&&nf(a,a.destination)}catch(P){W(a,P,{}),Te(a,P)}finally{Ce=f,Fe.current=c,Ge.current=d,c===De&&Jd(b),T=e}}}
function of(a,b,c){c.parentFlushed=!0;switch(c.status){case 0:c.id=a.nextSegmentId++;case 5:var d=c.id;c.lastPushedText=!1;c.textEmbedded=!1;a=a.renderState;b.push('<template id="');b.push(a.placeholderPrefix);a=d.toString(16);b.push(a);return b.push('"></template>');case 1:c.status=2;var e=!0;d=c.chunks;var f=0;c=c.children;for(var g=0;g<c.length;g++){for(e=c[g];f<e.index;f++)b.push(d[f]);e=pf(a,b,e)}for(;f<d.length-1;f++)b.push(d[f]);f<d.length&&(e=b.push(d[f]));return e;default:throw Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
}}
function pf(a,b,c){var d=c.boundary;if(null===d)return of(a,b,c);d.parentFlushed=!0;if(4===d.status)return a.renderState.generateStaticMarkup||(d=d.errorDigest,b.push("\x3c!--$!--\x3e"),b.push("<template"),d&&(b.push(' data-dgst="'),d=z(d),b.push(d),b.push('"')),b.push("></template>")),of(a,b,c),a=a.renderState.generateStaticMarkup?!0:b.push("\x3c!--/$--\x3e"),a;if(1!==d.status)return 0===d.status&&(d.rootSegmentID=a.nextSegmentId++),0<d.completedSegments.length&&a.partialBoundaries.push(d),Vb(b,a.renderState,
d.rootSegmentID),of(a,b,c),b.push("\x3c!--/$--\x3e");if(d.byteSize>a.progressiveChunkSize)return d.rootSegmentID=a.nextSegmentId++,a.completedBoundaries.push(d),Vb(b,a.renderState,d.rootSegmentID),of(a,b,c),b.push("\x3c!--/$--\x3e");c=d.resources;var e=a.renderState.boundaryResources;e&&(c.styles.forEach(Bc,e),c.stylesheets.forEach(Cc,e));a.renderState.generateStaticMarkup||b.push("\x3c!--$--\x3e");c=d.completedSegments;if(1!==c.length)throw Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
pf(a,b,c[0]);a=a.renderState.generateStaticMarkup?!0:b.push("\x3c!--/$--\x3e");return a}function qf(a,b,c){Wb(b,a.renderState,c.parentFormatContext,c.id);pf(a,b,c);return Xb(b,c.parentFormatContext)}
function rf(a,b,c){a.renderState.boundaryResources=c.resources;for(var d=c.completedSegments,e=0;e<d.length;e++)sf(a,b,c,d[e]);d.length=0;oc(b,c.resources,a.renderState);d=a.resumableState;a=a.renderState;e=c.rootSegmentID;c=c.resources;var f=a.stylesToHoist;a.stylesToHoist=!1;var g=0===d.streamingFormat;g?(b.push(a.startInlineScript),f?0===(d.instructions&2)?(d.instructions|=10,b.push('$RC=function(b,c,e){c=document.getElementById(c);c.parentNode.removeChild(c);var a=document.getElementById(b);if(a){b=a.previousSibling;if(e)b.data="$!",a.setAttribute("data-dgst",e);else{e=b.parentNode;a=b.nextSibling;var f=0;do{if(a&&8===a.nodeType){var d=a.data;if("/$"===d)if(0===f)break;else f--;else"$"!==d&&"$?"!==d&&"$!"!==d||f++}d=a.nextSibling;e.removeChild(a);a=d}while(a);for(;c.firstChild;)e.insertBefore(c.firstChild,a);b.data="$"}b._reactRetry&&b._reactRetry()}};$RM=new Map;\n$RR=function(r,t,w){for(var u=$RC,n=$RM,p=new Map,q=document,g,b,h=q.querySelectorAll("link[data-precedence],style[data-precedence]"),v=[],k=0;b=h[k++];)"not all"===b.getAttribute("media")?v.push(b):("LINK"===b.tagName&&n.set(b.getAttribute("href"),b),p.set(b.dataset.precedence,g=b));b=0;h=[];var l,a;for(k=!0;;){if(k){var f=w[b++];if(!f){k=!1;b=0;continue}var c=!1,m=0;var d=f[m++];if(a=n.get(d)){var e=a._p;c=!0}else{a=q.createElement("link");a.href=d;a.rel="stylesheet";for(a.dataset.precedence=\nl=f[m++];e=f[m++];)a.setAttribute(e,f[m++]);e=a._p=new Promise(function(x,y){a.onload=x;a.onerror=y});n.set(d,a)}d=a.getAttribute("media");!e||"l"===e.s||d&&!matchMedia(d).matches||h.push(e);if(c)continue}else{a=v[b++];if(!a)break;l=a.getAttribute("data-precedence");a.removeAttribute("media")}c=p.get(l)||g;c===g&&(g=a);p.set(l,a);c?c.parentNode.insertBefore(a,c.nextSibling):(c=q.head,c.insertBefore(a,c.firstChild))}Promise.all(h).then(u.bind(null,r,t,""),u.bind(null,r,t,"Resource failed to load"))};$RR("')):
0===(d.instructions&8)?(d.instructions|=8,b.push('$RM=new Map;\n$RR=function(r,t,w){for(var u=$RC,n=$RM,p=new Map,q=document,g,b,h=q.querySelectorAll("link[data-precedence],style[data-precedence]"),v=[],k=0;b=h[k++];)"not all"===b.getAttribute("media")?v.push(b):("LINK"===b.tagName&&n.set(b.getAttribute("href"),b),p.set(b.dataset.precedence,g=b));b=0;h=[];var l,a;for(k=!0;;){if(k){var f=w[b++];if(!f){k=!1;b=0;continue}var c=!1,m=0;var d=f[m++];if(a=n.get(d)){var e=a._p;c=!0}else{a=q.createElement("link");a.href=d;a.rel="stylesheet";for(a.dataset.precedence=\nl=f[m++];e=f[m++];)a.setAttribute(e,f[m++]);e=a._p=new Promise(function(x,y){a.onload=x;a.onerror=y});n.set(d,a)}d=a.getAttribute("media");!e||"l"===e.s||d&&!matchMedia(d).matches||h.push(e);if(c)continue}else{a=v[b++];if(!a)break;l=a.getAttribute("data-precedence");a.removeAttribute("media")}c=p.get(l)||g;c===g&&(g=a);p.set(l,a);c?c.parentNode.insertBefore(a,c.nextSibling):(c=q.head,c.insertBefore(a,c.firstChild))}Promise.all(h).then(u.bind(null,r,t,""),u.bind(null,r,t,"Resource failed to load"))};$RR("')):
b.push('$RR("'):0===(d.instructions&2)?(d.instructions|=2,b.push('$RC=function(b,c,e){c=document.getElementById(c);c.parentNode.removeChild(c);var a=document.getElementById(b);if(a){b=a.previousSibling;if(e)b.data="$!",a.setAttribute("data-dgst",e);else{e=b.parentNode;a=b.nextSibling;var f=0;do{if(a&&8===a.nodeType){var d=a.data;if("/$"===d)if(0===f)break;else f--;else"$"!==d&&"$?"!==d&&"$!"!==d||f++}d=a.nextSibling;e.removeChild(a);a=d}while(a);for(;c.firstChild;)e.insertBefore(c.firstChild,a);b.data="$"}b._reactRetry&&b._reactRetry()}};$RC("')):
b.push('$RC("')):f?b.push('<template data-rri="" data-bid="'):b.push('<template data-rci="" data-bid="');d=e.toString(16);b.push(a.boundaryPrefix);b.push(d);g?b.push('","'):b.push('" data-sid="');b.push(a.segmentPrefix);b.push(d);f?g?(b.push('",'),uc(b,c)):(b.push('" data-sty="'),vc(b,c)):g&&b.push('"');d=g?b.push(")\x3c/script>"):b.push('"></template>');return Ub(b,a)&&d}
function sf(a,b,c,d){if(2===d.status)return!0;var e=d.id;if(-1===e){if(-1===(d.id=c.rootSegmentID))throw Error("A root segment ID must have been assigned by now. This is a bug in React.");return qf(a,b,d)}if(e===c.rootSegmentID)return qf(a,b,d);qf(a,b,d);c=a.resumableState;a=a.renderState;(d=0===c.streamingFormat)?(b.push(a.startInlineScript),0===(c.instructions&1)?(c.instructions|=1,b.push('$RS=function(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("')):
b.push('$RS("')):b.push('<template data-rsi="" data-sid="');b.push(a.segmentPrefix);e=e.toString(16);b.push(e);d?b.push('","'):b.push('" data-pid="');b.push(a.placeholderPrefix);b.push(e);b=d?b.push('")\x3c/script>'):b.push('"></template>');return b}
function nf(a,b){try{var c,d=a.completedRootSegment;if(null!==d)if(5!==d.status&&0===a.pendingRootTasks){var e=a.renderState;if((0!==a.allPendingTasks||null!==a.trackedPostpones)&&e.externalRuntimeScript){var f=e.externalRuntimeScript,g=a.resumableState,h=f.src,k=f.chunks;g.scriptResources.hasOwnProperty(h)||(g.scriptResources[h]=null,e.scripts.add(k))}var l=e.htmlChunks,m=e.headChunks;f=0;if(l){for(f=0;f<l.length;f++)b.push(l[f]);if(m)for(f=0;f<m.length;f++)b.push(m[f]);else{var p=N("head");b.push(p);
b.push(">")}}else if(m)for(f=0;f<m.length;f++)b.push(m[f]);var n=e.charsetChunks;for(f=0;f<n.length;f++)b.push(n[f]);n.length=0;e.preconnects.forEach(Q,b);e.preconnects.clear();var q=e.preconnectChunks;for(f=0;f<q.length;f++)b.push(q[f]);q.length=0;e.fontPreloads.forEach(Q,b);e.fontPreloads.clear();e.highImagePreloads.forEach(Q,b);e.highImagePreloads.clear();e.styles.forEach(rc,b);var C=e.importMapChunks;for(f=0;f<C.length;f++)b.push(C[f]);C.length=0;e.bootstrapScripts.forEach(Q,b);e.scripts.forEach(Q,
b);e.scripts.clear();e.bulkPreloads.forEach(Q,b);e.bulkPreloads.clear();var A=e.preloadChunks;for(f=0;f<A.length;f++)b.push(A[f]);A.length=0;var x=e.hoistableChunks;for(f=0;f<x.length;f++)b.push(x[f]);x.length=0;if(l&&null===m){var u=Mb("head");b.push(u)}pf(a,b,d);a.completedRootSegment=null;Ub(b,a.renderState)}else return;var t=a.renderState;d=0;t.preconnects.forEach(Q,b);t.preconnects.clear();var E=t.preconnectChunks;for(d=0;d<E.length;d++)b.push(E[d]);E.length=0;t.fontPreloads.forEach(Q,b);t.fontPreloads.clear();
t.highImagePreloads.forEach(Q,b);t.highImagePreloads.clear();t.styles.forEach(tc,b);t.scripts.forEach(Q,b);t.scripts.clear();t.bulkPreloads.forEach(Q,b);t.bulkPreloads.clear();var w=t.preloadChunks;for(d=0;d<w.length;d++)b.push(w[d]);w.length=0;var r=t.hoistableChunks;for(d=0;d<r.length;d++)b.push(r[d]);r.length=0;var D=a.clientRenderedBoundaries;for(c=0;c<D.length;c++){var O=D[c];t=b;var F=a.resumableState,ha=a.renderState,R=O.rootSegmentID,P=O.errorDigest,oa=O.errorMessage,ia=O.errorComponentStack,
Y=0===F.streamingFormat;Y?(t.push(ha.startInlineScript),0===(F.instructions&4)?(F.instructions|=4,t.push('$RX=function(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};;$RX("')):t.push('$RX("')):t.push('<template data-rxi="" data-bid="');t.push(ha.boundaryPrefix);var Ta=R.toString(16);t.push(Ta);Y&&t.push('"');if(P||oa||ia)if(Y){t.push(",");var Ua=Zb(P||"");t.push(Ua)}else{t.push('" data-dgst="');
var Va=z(P||"");t.push(Va)}if(oa||ia)if(Y){t.push(",");var pa=Zb(oa||"");t.push(pa)}else{t.push('" data-msg="');var S=z(oa||"");t.push(S)}if(ia)if(Y){t.push(",");var tb=Zb(ia);t.push(tb)}else{t.push('" data-stck="');var qa=z(ia);t.push(qa)}if(Y?!t.push(")\x3c/script>"):!t.push('"></template>')){a.destination=null;c++;D.splice(0,c);return}}D.splice(0,c);var ra=a.completedBoundaries;for(c=0;c<ra.length;c++)if(!rf(a,b,ra[c])){a.destination=null;c++;ra.splice(0,c);return}ra.splice(0,c);var ca=a.partialBoundaries;
for(c=0;c<ca.length;c++){var sa=ca[c];a:{D=a;O=b;D.renderState.boundaryResources=sa.resources;var ta=sa.completedSegments;for(F=0;F<ta.length;F++)if(!sf(D,O,sa,ta[F])){F++;ta.splice(0,F);var Wa=!1;break a}ta.splice(0,F);Wa=oc(O,sa.resources,D.renderState)}if(!Wa){a.destination=null;c++;ca.splice(0,c);return}}ca.splice(0,c);var ua=a.completedBoundaries;for(c=0;c<ua.length;c++)if(!rf(a,b,ua[c])){a.destination=null;c++;ua.splice(0,c);return}ua.splice(0,c)}finally{0===a.allPendingTasks&&0===a.pingedTasks.length&&
0===a.clientRenderedBoundaries.length&&0===a.completedBoundaries.length&&(a.flushScheduled=!1,null===a.trackedPostpones&&(c=a.resumableState,c.hasBody&&(ca=Mb("body"),b.push(ca)),c.hasHtml&&(c=Mb("html"),b.push(c))),b.push(null),a.destination=null)}}function tf(a){a.flushScheduled=null!==a.destination;Oe(a);null===a.trackedPostpones&&mf(a,0===a.pendingRootTasks)}
function yc(a){if(!1===a.flushScheduled&&0===a.pingedTasks.length&&null!==a.destination){a.flushScheduled=!0;var b=a.destination;b?nf(a,b):a.flushScheduled=!1}}function uf(a,b){if(1===a.status)a.status=2,b.destroy(a.fatalError);else if(2!==a.status&&null===a.destination){a.destination=b;try{nf(a,b)}catch(c){W(a,c,{}),Te(a,c)}}}
function vf(a,b){try{var c=a.abortableTasks;if(0<c.size){var d=void 0===b?Error("The render was aborted by the server without a reason."):b;c.forEach(function(e){return jf(e,a,d)});c.clear()}null!==a.destination&&nf(a,a.destination)}catch(e){W(a,e,{}),Te(a,e)}}function ef(a,b,c){if(null===b)c.rootNodes.push(a);else{var d=c.workingMap,e=d.get(b);void 0===e&&(e=[b[1],b[2],[],null],d.set(b,e),ef(e,b[0],c));e[2].push(a)}}function wf(){}
function xf(a,b,c,d){var e=!1,f=null,g="",h=!1;b=nb(b?b.identifierPrefix:void 0,void 0);a=Je(a,b,Dc(b,c),ob(),Infinity,wf,void 0,function(){h=!0},void 0,void 0,void 0);tf(a);vf(a,d);uf(a,{push:function(k){null!==k&&(g+=k);return!0},destroy:function(k){e=!0;f=k}});if(e&&f!==d)throw f;if(!h)throw Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");return g}
function yf(a,b){a.prototype=Object.create(b.prototype);a.prototype.constructor=a;a.__proto__=b}var zf=function(a){function b(){var d=a.call(this,{})||this;d.request=null;d.startedFlowing=!1;return d}yf(b,a);var c=b.prototype;c._destroy=function(d,e){vf(this.request);e(d)};c._read=function(){this.startedFlowing&&uf(this.request,this)};return b}(ea.Readable);function Af(){}
function Bf(a,b){var c=new zf;b=nb(b?b.identifierPrefix:void 0,void 0);var d=Je(a,b,Dc(b,!1),ob(),Infinity,Af,function(){c.startedFlowing=!0;uf(d,c)},void 0,void 0,void 0);c.request=d;tf(d);return c}exports.renderToNodeStream=function(a,b){return Bf(a,b)};exports.renderToStaticMarkup=function(a,b){return xf(a,b,!0,'The server used "renderToStaticMarkup" which does not support Suspense. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server')};
exports.renderToStaticNodeStream=function(a,b){return Bf(a,b)};exports.renderToString=function(a,b){return xf(a,b,!1,'The server used "renderToString" which does not support Suspense. If you intended for this Suspense boundary to render the fallback content on the server consider throwing an Error somewhere within the Suspense boundary. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server')};
exports.version="18.3.0-experimental-60a927d04-20240113";

//# sourceMappingURL=react-dom-server-legacy.node.production.min.js.map
